Imports System.Math
Module Calcul
    Public Sub Calcul_Pieux()
        'NOTA IMPORTANT :
        'Les units doivent tre en KN, m, KPa
        'variables locales
        Dim i1, i3, i4, i5, ii, i_typ, i_eff, i_couch, i_file As Integer
        Dim aa, ab, bb, cb, db, det, dd, eb, fb, ga, gb, gc, gd, ge, gf, Tga, Tgb, Tgc, Tgd, Tge, Tgf As Double
        Dim a(Maxxx(np, Ty, Maxx(nf, Ty))), b(Maxxx(np, Ty, Maxx(nf, Ty))), c(Maxxx(np, Ty, Maxx(nf, Ty))), d(Maxxx(np, Ty, Maxx(nf, Ty))) As Double
        Dim e(Maxxx(np, Ty, Maxx(nf, Ty))), EI(2, Ty), f(Maxxx(np, Ty, Maxx(nf, Ty))) As Double
        Dim g1(Maxx(nCouche, Ty)), g2(Maxx(nCouche, Ty)), g3(Maxx(nCouche, Ty)), g4(Maxx(nCouche, Ty)) As Double
        Dim rd(Maxx(nCouche, Ty)), re(Maxx(nCouche, Ty)) As Double
        Dim gg0(Maxx(nCouche, Ty)), gg1(Maxx(nCouche, Ty)), gg2(Maxx(nCouche, Ty)), gg3(Maxx(nCouche, Ty)), gg4(Maxx(nCouche, Ty)) As Double
        Dim k1(Maxx(nCouche, Ty)), k2(Maxx(nCouche, Ty)), k3(Maxx(nCouche, Ty)) As Double
        Dim f0(Precision), f1(Precision), f2(Precision), f3(Precision), ff0(Precision), ff1(Precision) As Double
        Dim ff2(Precision), ff3(Precision), (2, Ty) As Double
        Dim dy(2, Ty, Maxx(nf, Ty)), dz(2, Ty, Maxx(nf, Ty)) As Double
        Dim dzp(2, Ty, Maxx(nf, Ty)) As Double
        Dim u() As Double
        If Maxx(nCouche, Ty) > Precision Then
            ReDim u(Maxx(nCouche, Ty))
        Else
            ReDim u(Precision)
        End If
        'variables publiques
        ReDim ro1(2, Ty), ro2(2, Ty), ro3(2, Ty)
        ReDim max_M(3, Ty, Maxx(nf, Ty)), max_T(3, Ty, Maxx(nf, Ty)), max_Rot(3, Ty, Maxx(nf, Ty))
        ReDim max_Depl(3, Ty, Maxx(nf, Ty)), max_Pl(3, Ty, Maxx(nf, Ty))
        i1 = Maxx(nCouche, Ty) * Precision
        ReDim m(3, Ty, Maxx(nf, Ty), i1), t(3, Ty, Maxx(nf, Ty), i1), z(Ty, i1), pl(3, Ty, Maxx(nf, Ty), i1)
        ReDim dyp(3, Ty, Maxx(nf, Ty), i1), om(3, Ty, Maxx(nf, Ty), i1), n(3, Ty, Maxx(nf, Ty))

        Dim toto As Double

        '->Calcul des coefficients croiss
        Call Rigidite_Flex(EI) 'calcul de la rigidit flexionnelle du pieu sous efforts instantans ou soutenus
        Call Mise_a_jour_K() 'application du coefficient FOND72  tous les modules de raction
        For i_typ = 1 To Ty ' bouclage suivant le type de pieu
            For i_eff = 1 To 2 'bouclage suivant efforts soutenus et instantanes:'1 = soutenus, 2 = instantans
                For i_couch = 1 To nCouche(i_typ) 'bouclage suivant couches
                    re(i_couch) = (k(i_typ, i_couch, i_eff) * dp(i_typ)) / (4 * EI(i_eff, i_typ)) '  calcul de 1/lo^4
                    If re(i_couch) = 0 Then
                        g4(i_couch) = ((2 * h(i_typ, i_couch)) ^ 4) / 24
                        g1(i_couch) = 2 * h(i_typ, i_couch)
                        g2(i_couch) = ((2 * h(i_typ, i_couch)) ^ 2) / 2
                        g3(i_couch) = ((2 * h(i_typ, i_couch)) ^ 3) / 6
                    Else
                        rd(i_couch) = 1 / re(i_couch) : u(i_couch) = h(i_typ, i_couch) * re(i_couch) ^ 0.25
                        If u(i_couch) <= 0.025 Then
                            g4(i_couch) = ((2 * h(i_typ, i_couch)) ^ 4) / 24
                            g1(i_couch) = 2 * h(i_typ, i_couch)
                            g2(i_couch) = ((2 * h(i_typ, i_couch)) ^ 2) / 2
                            g3(i_couch) = ((2 * h(i_typ, i_couch)) ^ 3) / 6
                        Else
                            gg0(i_couch) = 0.5 * (fnch(2 * u(i_couch)) + Cos(2 * u(i_couch)))
                            gg1(i_couch) = 0.5 * (fnsh(2 * u(i_couch)) + Sin(2 * u(i_couch)))
                            gg2(i_couch) = 0.5 * (fnch(2 * u(i_couch)) - Cos(2 * u(i_couch)))
                            gg3(i_couch) = 0.5 * (fnsh(2 * u(i_couch)) - Sin(2 * u(i_couch)))
                            g1(i_couch) = gg1(i_couch) / (re(i_couch) ^ 0.25)
                            g2(i_couch) = gg2(i_couch) / (re(i_couch) ^ 0.5)
                            g3(i_couch) = gg3(i_couch) / (re(i_couch) ^ 0.75)
                            g4(i_couch) = (gg0(i_couch) - 1) / re(i_couch)
                        End If
                    End If
                    If i_couch = 1 Then
                        Select Case ipp(i_typ)
                            Case 1 'pieu libre en pied
                                If k(i_typ, i_couch, i_eff) = 0 Then
                                    k1(i_couch) = 0 : k2(i_couch) = 0 : k3(i_couch) = 0
                                Else
                                    k1(i_couch) = 2 * (2 * g1(i_couch) * re(i_couch)) / (1 + gg0(i_couch))
                                    k2(i_couch) = (2 * g2(i_couch) * re(i_couch)) / (1 + gg0(i_couch))
                                    k3(i_couch) = (2 * g3(i_couch) * re(i_couch)) / (1 + gg0(i_couch))
                                End If
                            Case 2 'pieu articul en pied
                                If k(i_typ, i_couch, i_eff) = 0 Then
                                    k1(i_couch) = 3 / (h(i_typ, i_couch) ^ 3)
                                    k2(i_couch) = 3 / (h(i_typ, i_couch) ^ 2)
                                    k3(i_couch) = 3 / h(i_typ, i_couch)
                                Else
                                    k1(i_couch) = 4 * gg0(i_couch) / g3(i_couch)
                                    k2(i_couch) = 2 * g1(i_couch) / g3(i_couch)
                                    k3(i_couch) = 2 * g2(i_couch) / g3(i_couch)
                                End If
                            Case 3 'pieu encastr en pied
                                If k(i_typ, i_couch, i_eff) = 0 Then
                                    k1(i_couch) = 12 / h(i_typ, i_couch) ^ 3
                                    k2(i_couch) = 6 / h(i_typ, i_couch) ^ 2
                                    k3(i_couch) = 4 / h(i_typ, i_couch)
                                Else
                                    k1(i_couch) = 4 * g1(i_couch) / g4(i_couch)
                                    k2(i_couch) = 2 * g2(i_couch) / g4(i_couch)
                                    k3(i_couch) = 2 * g3(i_couch) / g4(i_couch)
                                End If
                        End Select
                    Else
                        aa = ((k1(i_couch - 1) * k3(i_couch - 1) - k2(i_couch - 1) ^ 2) + (4 * re(i_couch))) / 4
                        dd = (2 + g4(i_couch) * aa + g3(i_couch) * k1(i_couch - 1) / 2 + g2(i_couch) * k2(i_couch - 1) + g1(i_couch) * k3(i_couch - 1)) / 2
                        k1(i_couch) = k1(i_couch - 1) / 2 + g1(i_couch) * aa + g4(i_couch) * (re(i_couch)) * k1(i_couch - 1) / 2 + g3(i_couch) * re(i_couch) * k2(i_couch - 1)
                        k1(i_couch) = (k1(i_couch) + g2(i_couch) * re(i_couch) * k3(i_couch - 1)) * (2 / dd)
                        k2(i_couch) = k2(i_couch - 1) + g2(i_couch) * aa + g1(i_couch) * k1(i_couch - 1) / 2 + g4(i_couch) * re(i_couch) * k2(i_couch - 1) + g3(i_couch) * re(i_couch) * k3(i_couch - 1)
                        k2(i_couch) = k2(i_couch) / dd
                        k3(i_couch) = (k3(i_couch - 1) + g3(i_couch) * aa + g2(i_couch) * k1(i_couch - 1) / 2 + g1(i_couch) * k2(i_couch - 1) + g4(i_couch) * re(i_couch) * k3(i_couch - 1)) / dd
                    End If
                Next
                ro1(i_eff, i_typ) = k1(nCouche(i_typ)) * EI(i_eff, i_typ)
                ro2(i_eff, i_typ) = k2(nCouche(i_typ)) * EI(i_eff, i_typ)
                ro3(i_eff, i_typ) = k3(nCouche(i_typ)) * EI(i_eff, i_typ)
            Next
        Next
        '
        'Calcul des dplacements de la semelle et de la rpartition des efforts entre pieux
        '
        '-> calcul sur les tirants
        Tga = 0 : Tgb = 0 : Tgc = 0 : Tgd = 0 : Tge = 0 : Tgf = 0
        For i1 = 1 To nbTirant
            a(i1) = muTirant / 2 + ((muTirant / 2) * Cos(2 * alphaTirant))
            b(i1) = 0
            c(i1) = muTirant / 2 - ((muTirant / 2) * Cos(2 * alphaTirant))
            d(i1) = 0
            e(i1) = 0
            f(i1) = (muTirant / 2) * Sin(2 * (alphaTirant))
            Tga = Tga + a(i1)
            Tgb = Tgb + b(i1) + Ytirant * (a(i1) * Ytirant + 2 * d(i1))
            Tgc = Tgc + c(i1)
            Tgd = Tgd + a(i1) * Ytirant + d(i1)
            Tge = Tge + f(i1) * Ytirant + e(i1)
            Tgf = Tgf + f(i1)
        Next
        '-> calcul sur les pieux

        Call Rigidite_Long()
        Select Case Encastre
            Case False 'pieux articuls sur la semelle
                '-> calcul des dplacements de la semelle dans le repre global - pieux articuls dans la semelle
                For i_eff = 1 To 2 'bouclage sur efforts SOUTENUS et INSTANTANES
                    ga = Tga : gb = Tgb : gc = Tgc : gd = Tgd : ge = Tge : gf = Tgf
                    For i_typ = 1 To Ty 'bouclage sur tout les types de pieux
                        For ii = 1 To nf(i_typ) ' bouclage sur toutes les files du pieux de type i_typ
                            For i1 = 1 To np(i_typ, ii) 'bouclage sur tout les pieux de la file ii
                                a(i1) = ((i_eff, i_typ) + ro1(i_eff, i_typ)) / 2 + ((((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Cos(2 * alpha(i_typ)))
                                b(i1) = 0
                                c(i1) = (((i_eff, i_typ) + ro1(i_eff, i_typ)) / 2) - ((((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Cos(2 * alpha(i_typ)))
                                d(i1) = 0
                                e(i1) = 0
                                f(i1) = (((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Sin(2 * (alpha(i_typ)))
                                ga = ga + a(i1)
                                gb = gb + a(i1) * y(i_typ, ii) ^ 2
                                gc = gc + c(i1)
                                gd = gd + a(i1) * y(i_typ, ii)
                                ge = ge + f(i1) * y(i_typ, ii)
                                gf = gf + f(i1)
                            Next
                        Next ii
                    Next i_typ
                    ab = gb * gc - ge ^ 2
                    db = ge * gf - gd * gc
                    fb = gd * ge - gb * gf
                    bb = ga * gc - gf ^ 2
                    cb = ga * gb - gd ^ 2
                    eb = gd * gf - ga * ge
                    det = ga * ab + gd * db + gf * fb
                    z0(i_eff) = (n0(i_eff) * ab + m0(i_eff) * db + t0(i_eff) * fb) / det
                    om0(i_eff) = (db * n0(i_eff) + bb * m0(i_eff) + eb * t0(i_eff)) / det
                    y0(i_eff) = (fb * n0(i_eff) + eb * m0(i_eff) + cb * t0(i_eff)) / det
                Next i_eff
                '-> efforts et dplacement en tte pour chaque pieu dans son repre local
                For i_eff = 1 To 2
                    For i_typ = 1 To Ty
                        For ii = 1 To nf(i_typ)
                            dy(i_eff, i_typ, ii) = y0(i_eff) 'repre global
                            dz(i_eff, i_typ, ii) = z0(i_eff) + y(i_typ, ii) * om0(i_eff) 'repre global
                            dyp(i_eff, i_typ, ii, 0) = dy(i_eff, i_typ, ii) * Cos(alpha(i_typ)) - dz(i_eff, i_typ, ii) * Sin(alpha(i_typ)) 'repre local
                            om(i_eff, i_typ, ii, 0) = (ro2(i_eff, i_typ) / ro3(i_eff, i_typ)) * dyp(i_eff, i_typ, ii, 0) 'repre 
                            dzp(i_eff, i_typ, ii) = dy(i_eff, i_typ, ii) * Sin(alpha(i_typ)) + dz(i_eff, i_typ, ii) * Cos(alpha(i_typ)) 'repre local
                            n(i_eff, i_typ, ii) = (i_eff, i_typ) * dzp(i_eff, i_typ, ii) 'repre local
                            m(i_eff, i_typ, ii, 0) = 0 'repre local
                            t(i_eff, i_typ, ii, 0) = ro1(i_eff, i_typ) * dyp(i_eff, i_typ, ii, 0) - ro2(i_eff, i_typ) * om(i_eff, i_typ, ii, 0) 'repre local
                        Next
                    Next
                Next
            Case True 'pieux encastrs sur la semelle
                '-> calcul des dplacements de la semelle dans le repre global - pieux encastr dans la semelle
                For i_eff = 1 To 2 'bouclage sur efforts SOUTENUS et INSTANTANES
                    ga = Tga : gb = Tgb : gc = Tgc : gd = Tgd : ge = Tge : gf = Tgf
                    For i_typ = 1 To Ty 'bouclage sur tout les types de pieux
                        For ii = 1 To nf(i_typ) ' bouclage sur toutes les files du pieux de type i_typ
                            For i1 = 1 To np(i_typ, ii) 'bouclage sur tout les pieux de la file ii
                                a(i1) = ((i_eff, i_typ) + ro1(i_eff, i_typ)) / 2 + ((((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Cos(2 * alpha(i_typ)))
                                b(i1) = ro3(i_eff, i_typ)
                                c(i1) = (((i_eff, i_typ) + ro1(i_eff, i_typ)) / 2) - ((((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Cos(2 * alpha(i_typ)))
                                d(i1) = ro2(i_eff, i_typ) * Sin(alpha(i_typ))
                                e(i1) = -ro2(i_eff, i_typ) * Cos(alpha(i_typ))
                                f(i1) = (((i_eff, i_typ) - ro1(i_eff, i_typ)) / 2) * Sin(2 * (alpha(i_typ)))
                                ga = ga + a(i1)
                                gb = gb + b(i1) + y(i_typ, ii) * (a(i1) * y(i_typ, ii) + 2 * d(i1))
                                gc = gc + c(i1)
                                gd = gd + a(i1) * y(i_typ, ii) + d(i1)
                                ge = ge + f(i1) * y(i_typ, ii) + e(i1)
                                gf = gf + f(i1)
                            Next
                        Next ii
                    Next i_typ
                    ab = gb * gc - ge ^ 2
                    db = ge * gf - gd * gc
                    fb = gd * ge - gb * gf
                    bb = ga * gc - gf ^ 2
                    cb = ga * gb - gd ^ 2
                    eb = gd * gf - ga * ge
                    det = ga * ab + gd * db + gf * fb
                    z0(i_eff) = (n0(i_eff) * ab + m0(i_eff) * db + t0(i_eff) * fb) / det
                    om0(i_eff) = (db * n0(i_eff) + bb * m0(i_eff) + eb * t0(i_eff)) / det
                    y0(i_eff) = (fb * n0(i_eff) + eb * m0(i_eff) + cb * t0(i_eff)) / det
                Next i_eff
                '-> efforts et dplacement en tte pour chaque pieu dans son repre local
                For i_eff = 1 To 2
                    For i_typ = 1 To Ty
                        For ii = 1 To nf(i_typ)
                            dy(i_eff, i_typ, ii) = y0(i_eff) 'repre global
                            dz(i_eff, i_typ, ii) = z0(i_eff) + y(i_typ, ii) * om0(i_eff) 'repre global
                            om(i_eff, i_typ, ii, 0) = om0(i_eff) 'repre global
                            dyp(i_eff, i_typ, ii, 0) = dy(i_eff, i_typ, ii) * Cos(alpha(i_typ)) - dz(i_eff, i_typ, ii) * Sin(alpha(i_typ)) 'repre local
                            dzp(i_eff, i_typ, ii) = dy(i_eff, i_typ, ii) * Sin(alpha(i_typ)) + dz(i_eff, i_typ, ii) * Cos(alpha(i_typ)) 'repre local
                            n(i_eff, i_typ, ii) = (i_eff, i_typ) * dzp(i_eff, i_typ, ii) 'repre local
                            toto = n(i_eff, i_typ, ii)
                            m(i_eff, i_typ, ii, 0) = -ro2(i_eff, i_typ) * dyp(i_eff, i_typ, ii, 0) + ro3(i_eff, i_typ) * om(i_eff, i_typ, ii, 0) 'repre local
                            toto = m(i_eff, i_typ, ii, 0)
                            t(i_eff, i_typ, ii, 0) = ro1(i_eff, i_typ) * dyp(i_eff, i_typ, ii, 0) - ro2(i_eff, i_typ) * om(i_eff, i_typ, ii, 0) 'repre local
                            toto = t(i_eff, i_typ, ii, 0)
                        Next
                    Next
                Next
        End Select
        '-> effort dans le tirant
        If nbTirant > 0.1 Then
            For i_eff = 1 To 2
                dy(i_eff, 0, 0) = y0(i_eff) 'repre global
                dz(i_eff, 0, 0) = z0(i_eff) + Ytirant * om0(i_eff) 'repre global
                dzp(i_eff, 0, 0) = dy(i_eff, 0, 0) * Sin(alphaTirant) + dz(i_eff, 0, 0)
                n(i_eff, 0, 0) = muTirant * dzp(i_eff, 0, 0) 'repre local
            Next
        End If
        '
        'PROGRAMME DE CALCUL DES EFFORTS  DE M ET DE T SUR LA LONGUEUR DU PIEU 

        'm(1, 1, 1) = m0(1) : t(1, 1, 1) = t0(1) : m(2, 1, 1) = m0(2) : t(2, 1, 1) = t0(2)
        For i_eff = 1 To 2
            For i_typ = 1 To Ty
                For ii = 1 To nf(i_typ)
                    max_M(i_eff, i_typ, ii) = 0 : max_T(i_eff, i_typ, ii) = 0 : max_Rot(i_eff, i_typ, ii) = 0
                    max_Depl(i_eff, i_typ, ii) = 0 : max_Pl(i_eff, i_typ, ii) = 0
                Next
            Next
        Next
        For i_typ = 1 To Ty 'bouclage sur tout les types de pieux choisis
            'inversions des couches de sols
            For i1 = 1 To CInt(Truncate(nCouche(i_typ) / 2))
                aa = h(i_typ, i1)
                ab = k(i_typ, i1, 2)
                h(i_typ, i1) = h(i_typ, nCouche(i_typ) - i1 + 1)
                k(i_typ, i1, 2) = k(i_typ, nCouche(i_typ) - i1 + 1, 2)
                h(i_typ, nCouche(i_typ) - i1 + 1) = aa
                k(i_typ, nCouche(i_typ) - i1 + 1, 2) = ab
            Next
            For i1 = 1 To nCouche(i_typ)
                k(i_typ, i1, 1) = k(i_typ, i1, 2) / Fond72
            Next i1
            'calcul effectu pour chaque file de pieu de type i_typ
            For i_file = 1 To nf(i_typ)
                For i_eff = 1 To 2 'bouclage suivant le type d'efforts soutenus et instantans
                    aa = ro1(i_eff, i_typ) * ro3(i_eff, i_typ) - ro2(i_eff, i_typ) ^ 2
                    ab = ro3(i_eff, i_typ) / aa : cb = ro2(i_eff, i_typ) / aa
                    bb = ro2(i_eff, i_typ) / aa : db = ro1(i_eff, i_typ) / aa
                    i5 = 0
                    dyp(i_eff, i_typ, i_file, i5) = ab * t(i_eff, i_typ, i_file, 0) + cb * m(i_eff, i_typ, i_file, 0)
                    toto = dyp(i_eff, i_typ, i_file, i5)
                    om(i_eff, i_typ, i_file, i5) = bb * t(i_eff, i_typ, i_file, 0) + db * m(i_eff, i_typ, i_file, 0)
                    'toto = rr(i_eff, i_typ, i5)
                    m(i_eff, i_typ, i_file, i5) = m(i_eff, i_typ, i_file, 0) / EI(i_eff, i_typ)
                    t(i_eff, i_typ, i_file, i5) = t(i_eff, i_typ, i_file, 0) / EI(i_eff, i_typ)
                    z(i_typ, i5) = 0

                    For i_couch = 1 To nCouche(i_typ)
                        For i3 = 1 To Precision
                            re(i_couch) = k(i_typ, i_couch, i_eff) * dp(i_typ) / EI(i_eff, i_typ)
                            If k(i_typ, i_couch, i_eff) = 0 Then
                                f0(i3) = 1
                                f1(i3) = h(i_typ, i_couch) / Precision '* i3
                                f2(i3) = (h(i_typ, i_couch) / Precision) ^ 2 / 2 '* i3
                                f3(i3) = (h(i_typ, i_couch) / Precision) ^ 3 / 6 '* i3
                            Else
                                rd(i_couch) = 4 * EI(i_eff, i_typ) / (k(i_typ, i_couch, i_eff) * dp(i_typ))
                                u(i3) = (h(i_typ, i_couch) / Precision) / (rd(i_couch) ^ 0.25) ' * i3
                                If u(i3) <= 0.01 Then
                                    f0(i3) = 1
                                    f1(i3) = h(i_typ, i_couch) / Precision '* i3
                                    f2(i3) = (h(i_typ, i_couch) / Precision) ^ 2 / 2 '* i3
                                    f3(i3) = (h(i_typ, i_couch) / Precision) ^ 3 / 6 '* i3
                                Else
                                    ff0(i3) = fnch(u(i3)) * Cos(u(i3))
                                    ff1(i3) = 0.5 * (fnsh(u(i3)) * Cos(u(i3)) + fnch(u(i3)) * Sin(u(i3)))
                                    ff2(i3) = 0.5 * (fnsh(u(i3)) * Sin(u(i3)))
                                    ff3(i3) = 0.25 * (fnch(u(i3)) * Sin(u(i3)) - fnsh(u(i3)) * Cos(u(i3)))
                                    f0(i3) = ff0(i3)
                                    f1(i3) = ff1(i3) * rd(i_couch) ^ 0.25
                                    f2(i3) = ff2(i3) * rd(i_couch) ^ 0.5
                                    f3(i3) = ff3(i3) * rd(i_couch) ^ 0.75
                                End If
                            End If
                            dyp(i_eff, i_typ, i_file, i5 + 1) = f0(i3) * dyp(i_eff, i_typ, i_file, i5) - f1(i3) * om(i_eff, i_typ, i_file, i5) + f2(i3) * m(i_eff, i_typ, i_file, i5) + f3(i3) * t(i_eff, i_typ, i_file, i5)
                            toto = dyp(i_eff, i_typ, i_file, i5 + 1)
                            om(i_eff, i_typ, i_file, i5 + 1) = re(i_couch) * f3(i3) * dyp(i_eff, i_typ, i_file, i5) + f0(i3) * om(i_eff, i_typ, i_file, i5) - f1(i3) * m(i_eff, i_typ, i_file, i5) - f2(i3) * t(i_eff, i_typ, i_file, i5)
                            'toto = rr(i_eff, i_typ, i5 + 1)
                            m(i_eff, i_typ, i_file, i5 + 1) = -re(i_couch) * f2(i3) * dyp(i_eff, i_typ, i_file, i5) + re(i_couch) * f3(i3) * om(i_eff, i_typ, i_file, i5) + f0(i3) * m(i_eff, i_typ, i_file, i5) + f1(i3) * t(i_eff, i_typ, i_file, i5)
                            t(i_eff, i_typ, i_file, i5 + 1) = -re(i_couch) * f1(i3) * dyp(i_eff, i_typ, i_file, i5) + re(i_couch) * f2(i3) * om(i_eff, i_typ, i_file, i5) - re(i_couch) * f3(i3) * m(i_eff, i_typ, i_file, i5) + f0(i3) * t(i_eff, i_typ, i_file, i5)
                            z(i_typ, i5 + 1) = z(i_typ, i5) + h(i_typ, i_couch) / Precision
                            'toto = z(i_typ, i5 + 1)
                            i5 = i5 + 1
                            If max_Rot(i_eff, i_typ, i_file) < Abs(om(i_eff, i_typ, i_file, i5)) Then max_Rot(i_eff, i_typ, i_file) = Abs(om(i_eff, i_typ, i_file, i5))
                            If max_Depl(i_eff, i_typ, i_file) < Abs(dyp(i_eff, i_typ, i_file, i5)) Then max_Depl(i_eff, i_typ, i_file) = Abs(dyp(i_eff, i_typ, i_file, i5))
                        Next
                    Next
                    i4 = 1
                    For i3 = 0 To i5
                        If i3 > Precision * i4 Then i4 = i4 + 1
                        m(i_eff, i_typ, i_file, i3) = m(i_eff, i_typ, i_file, i3) * EI(i_eff, i_typ)
                        ' toto = m(i_eff, i_typ, i_file, i3)
                        If max_M(i_eff, i_typ, i_file) < Abs(m(i_eff, i_typ, i_file, i3)) Then max_M(i_eff, i_typ, i_file) = Abs(m(i_eff, i_typ, i_file, i3))
                        t(i_eff, i_typ, i_file, i3) = t(i_eff, i_typ, i_file, i3) * EI(i_eff, i_typ)
                        If max_T(i_eff, i_typ, i_file) < Abs(t(i_eff, i_typ, i_file, i3)) Then max_T(i_eff, i_typ, i_file) = Abs(t(i_eff, i_typ, i_file, i3))
                        'toto = t(i_eff, i_typ, i_file, i3)
                        If i3 = Precision * i4 And i4 <> nCouche(i_typ) Then
                            pl(i_eff, i_typ, i_file, i3) = -k(i_typ, i4 + 1, i_eff) * dyp(i_eff, i_typ, i_file, i3)
                        Else
                            pl(i_eff, i_typ, i_file, i3) = -k(i_typ, i4, i_eff) * dyp(i_eff, i_typ, i_file, i3)
                        End If
                        'toto = pl(i_eff, i_typ, i3)
                        If max_Pl(i_eff, i_typ, i_file) < Abs(pl(i_eff, i_typ, i_file, i3)) Then max_Pl(i_eff, i_typ, i_file) = Abs(pl(i_eff, i_typ, i_file, i3))
                    Next i3
                Next 'bouclage sur les efforts
            Next 'bouclage sur les files de pieux
        Next 'bouclage sur les types de pieux
        'pour re-inverser dans l'autre sens
        For i_typ = 1 To Ty 'bouclage sur tout les types de pieux choisis
            For i1 = 1 To CInt(Truncate(nCouche(i_typ) / 2))
                aa = h(i_typ, i1)
                ab = k(i_typ, i1, 2)
                h(i_typ, i1) = h(i_typ, nCouche(i_typ) - i1 + 1)
                k(i_typ, i1, 2) = k(i_typ, nCouche(i_typ) - i1 + 1, 2)
                h(i_typ, nCouche(i_typ) - i1 + 1) = aa
                k(i_typ, nCouche(i_typ) - i1 + 1, 2) = ab
            Next
            For i1 = 1 To nCouche(i_typ)
                k(i_typ, i1, 1) = k(i_typ, i1, 2) / Fond72 '2
            Next i1
        Next
        'cumul des efforts
        For i_typ = 1 To Ty
            For i_file = 1 To nf(i_typ)
                For i3 = 0 To i5
                    dyp(3, i_typ, i_file, i3) = dyp(1, i_typ, i_file, i3) + dyp(2, i_typ, i_file, i3)
                    toto = dyp(3, i_typ, i_file, i3)
                    If max_Depl(3, i_typ, i_file) < Abs(dyp(3, i_typ, i_file, i3)) Then max_Depl(3, i_typ, i_file) = Abs(dyp(3, i_typ, i_file, i3))
                    om(3, i_typ, i_file, i3) = om(1, i_typ, i_file, i3) + om(2, i_typ, i_file, i3)
                    If max_Rot(3, i_typ, i_file) < Abs(om(3, i_typ, i_file, i3)) Then max_Rot(3, i_typ, i_file) = Abs(om(3, i_typ, i_file, i3))
                    toto = om(3, i_typ, i_file, i3)
                    m(3, i_typ, i_file, i3) = m(1, i_typ, i_file, i3) + m(2, i_typ, i_file, i3)
                    toto = m(3, i_typ, i_file, i3)
                    If max_M(3, i_typ, i_file) < Abs(m(3, i_typ, i_file, i3)) Then max_M(3, i_typ, i_file) = Abs(m(3, i_typ, i_file, i3))
                    t(3, i_typ, i_file, i3) = t(1, i_typ, i_file, i3) + t(2, i_typ, i_file, i3)
                    If max_T(3, i_typ, i_file) < Abs(t(3, i_typ, i_file, i3)) Then max_T(3, i_typ, i_file) = Abs(t(3, i_typ, i_file, i3))
                    toto = t(3, i_typ, i_file, i3)
                    pl(3, i_typ, i_file, i3) = pl(1, i_typ, i_file, i3) + pl(2, i_typ, i_file, i3)
                    toto = pl(3, i_typ, i_file, i3)
                    If max_Pl(3, i_typ, i_file) < Abs(pl(3, i_typ, i_file, i3)) Then max_Pl(3, i_typ, i_file) = Abs(pl(3, i_typ, i_file, i3))
                Next i3
            Next
        Next
        Erase a, b, c, d
        Erase e, EI, f
        Erase g1, g2, g3, g4
        Erase rd, re
        Erase gg0, gg1, gg2, gg3, gg4
        Erase k1, k2, k3
        Erase f0, f1, f2, f3, ff0, ff1
        Erase ff2, ff3, 
        Erase dy, dz
        Erase dzp
        Erase u
    End Sub
    Private Sub Rigidite_Flex(ByRef EI(,) As Double)
        Dim i, j As Integer
        Dim Inertie As Double
        For i = 1 To Ty
            'calcul de l'inertie d'un pieu circulaire
            Inertie = PI * (dp(i) ^ 4) / 64
            For j = 1 To 2 'effort - 1 = soutenus et 2 = instantans
                EI(j, i) = Eyb(j) * Inertie * 1000 'EI en KPa
                'EI(j, i) = 1
            Next
        Next

    End Sub
    Private Sub Mise_a_jour_K()
        Dim i, i_typ As Integer
        For i_typ = 1 To Ty 'bouclage sur tout les types de pieux choisis
            For i = 1 To nCouche(i_typ)
                '1 = soutenus, 2 = instantans
                k(i_typ, i, 1) = k(i_typ, i, 2) / Fond72 ' sous effort soutenu, k = k mesur /2 (Fond 72)
            Next i
        Next
    End Sub
    Private Sub Rigidite_Long(ByRef (,) As Double)
        Dim i As Integer
        Dim S As Double
        For i = 1 To Ty 'EI en KPa
            S = PI * dp(i) ^ 2 / 4 : (1, i) = (Eyb(1) * S / l(i)) * 1000 : (2, i) = (Eyb(2) * S / l(i)) * 1000
            'If i = 1 Then (1, 1) = 5000 : (2, 1) = 5000
            'If i = 2 Then (1, 2) = 2500 * Sqrt(2) : (2, 2) = 2500 * Sqrt(2)
        Next
    End Sub
    Private Function fnch(ByVal x As Double) As Double
        'fonction Cosinus Hyperbolique
        fnch = (Exp(x) + Exp(-x)) / 2
    End Function
    Private Function fnsh(ByVal x As Double) As Double
        'foncion Sinus Hyperbolique
        fnsh = (Exp(x) - Exp(-x)) / 2
    End Function
    Public Sub Calcul_Ferraillage(ByRef Verif As Boolean)
        Dim i, i1 As Integer
        Dim Asi, Asmin, rayon, Ns, Ms, d, Vu, Tu, Taumb, StMax, kr, ft, gamaS, gamaB, ut, Atst As Double
        Dim dio(10) As Double
        Dim msg As String
        ReDim st(Ty, Maxx(nf, Ty)), nbarL(Ty, Maxx(nf, Ty)), phiAL(Ty, Maxx(nf, Ty)), phiAt(Ty, Maxx(nf, Ty))
        ReDim nbarT(Ty, Maxx(nf, Ty)), lT(Ty, Maxx(nf, Ty))
        ReDim Nra(Ty, Maxx(nf, Ty)), Nrb(Ty, Maxx(nf, Ty)), Mra(Ty, Maxx(nf, Ty)), Mrb(Ty, Maxx(nf, Ty))
        ReDim Yn0(Ty, Maxx(nf, Ty)), Sb(Ty, Maxx(nf, Ty)), Sbmoy(Ty, Maxx(nf, Ty)), Sa(Ty, Maxx(nf, Ty), 1)
        'Vrification Aciers de Flexion

        Call Aciers(dio)

        For i = 1 To Ty
            'calcul section acier mini
            Select Case dp(i)
                Case Is < 1
                    Asmin = 0.005 * PI * dp(i) ^ 2 / 4
                Case Else
                    Asmin = 0.005 * Sqrt(1 / dp(i))
                    If Asmin < 0.0035 * PI * dp(i) ^ 2 / 4 Then Asmin = 0.0035 * PI * dp(i) ^ 2 / 4
            End Select
            For i1 = 1 To nf(i) 'calcul effectu pour toutes les files de pieux
                If phiALproj(i, i1) > 0.001 Then
                    Asi = nbarLproj(i, i1) * PI * phiALproj(i, i1) ^ 2 / 4
                    nbarL(i, i1) = nbarLproj(i, i1) : phiAL(i, i1) = phiALproj(i, i1) : phiAt(i, i1) = phiAtproj(i, i1)
                Else
                    msg = "Cette version logicielle ne permet que la vrification !"
                    MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Module de calcul")
                    Exit Sub
                    nbarL(i, i1) = 6 : phiAL(i, i1) = dio(4) : phiAt(i, i1) = dio(2)
                    Asi = nbarL(i, i1) * PI * phiAL(i, i1) ^ 2 / 4 'calcul avec le ferraillage mini CCTG 62
                End If
                If Asi < Asmin Then
                    Dim F_Asi, F_Asmin As String
                    F_Asi = Format(Asi * 10000, "###0.00") : F_Asmin = Format(Asmin * 10000, "###0.00")
                    msg = "Section d'acier insuffisante: " & F_Asi & " cm prvu pour" & _
                    F_Asmin & " cm requis. Modifiez vos aciers !"
                    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Module Calcul_ferraillage")
                    Verif = False
                    Exit Sub
                End If
                rayon = dp(i) / 2 - enr - phiAL(i, i1) / 2 - phiAt(i, i1)
                Select Case type_comb
                    Case 1, 2, 3 'comb ELU fond,Accidentel,Sismique
                        If n0(1) + n0(2) > 0 Then Ns = 0 Else Ns = n0(1) + n0(2)
                        Ms = max_M(3, i, i1) '
                        Call Calcul_ELU_section_circulaire(dp(i) / 2, 1, Asi, rayon, Ns, Ms, Verif, i, i1)
                        If Verif = False Then Exit Sub
                    Case 4 ' comb ELS
                        If n0(1) + n0(2) > 0 Then Ns = 0 Else Ns = n0(1) + n0(2)
                        Ms = max_M(3, i, i1)
                        Call Calcul_ELS_section_circulaire(dp(i) / 2, 1, Asi, rayon, Ns, Ms, Verif, i, i1)
                        If Verif = False Then Exit Sub
                End Select
            Next
        Next
        'calcul aciers tranchant
        For i = 1 To Ty
            For i1 = 1 To nf(i)
                d = dp(i) - enr - phiAL(i, i1) / 2 - phiAt(i, i1)
                Vu = max_T(3, i, i1) / 1000 'transformation KN -> MN
                Tu = 1.4 * Vu / (dp(i) * d)
                'Select Case ELU_ELS
                '    Case 1
                gamaB = Vgb : gamaS = Vgs 'combinaison fondamentale
                '    Case 2
                '        gamaB = agb : gamaS = ags 'combinaison acidentelle
                'End Select
                '--> Contraintes limites de cisaillement ELU
                Select Case fis
                    Case 1  'fissuration peu prjudiciable
                        Taumb = 0.2 * fc / gamaB   'limit  5 MPa, pour les poutres en fissuration peu prjudiciable
                        If Taumb > 5 Then Taumb = 5 'Cisail. adm. ELU(90) 
                    Case 2, 3  'fissuration prjudiciable ou trs prjudiciable
                        Taumb = 0.15 * fc / gamaB  'limit  4 MPa, pour les poutres en fissuration prjudiciable ou trs prjudiciable
                        If Taumb > 4 Then Taumb = 4 'Cisail. adm. ELU(At=0)
                End Select
                If Tu > Taumb Then   'article A.5.1,21
                    Dim F_t33, F_taumb, F_i1, F_i As String
                    F_t33 = Format(Tu, "##0.##") : F_taumb = Format(Taumb, "##0.##")
                    F_i1 = Format(i1, "##") : F_i = Format(i, "##")
                    msg = "La contrainte de cisaillement de l'me du pieu de type " & F_i & " de la" & _
                    vbCrLf & "file n" & F_i1 & " calcule gal  " & F_t33 & " MPa est suprieure au " & _
                    vbCrLf & "cisaillement admissible (= " & F_taumb & " MPa)! Modifiez la dimension du pieu."
                    MsgBox(msg, vbCritical Or vbOKOnly, "Calcul_Ferraillage")
                    Verif = False
                    Exit Sub
                End If
                If sism = 1 Then StMax = 0.5 * d Else StMax = 0.9 * d
                If StMax > 0.35 Then StMax = 0.35
                If StMax > 15 * phiAL(i, i1) Then StMax = 15 * phiAL(i, i1)
                ft = 0.06 * fc + 0.6    'BETON:Comp. a 28jours:fc Traction a 28 jours  : ft
                If ft > 3.3 Then ft = 3.3
                ut = 0.4 * dp(i) / fe    '% minimum
                Select Case fis  'ACIER contr. admissible(ELS):ss
                    Case 1, 2 'fissuration peu prjudiciable
                        kr = 1 'pas de reprise de btonnage
                    Case 3  'fissuration trs prjudiciable
                        kr = 0
                End Select
                'vrification si le diamtre de l'acier d'effort tranchant est impos
                'If phiAtProj(i1) > 0.001 Then i3 = Indice_Acier(phiAtProj(i1)) Else i3 = 1
                If sism = 1 Then
                    Atst = Tu * dp(i) * 1.25 / (0.8 * fe) 'commentaire 11.815 PS92
                Else
                    Atst = (Tu - 0.3 * kr * ft) * dp(i) * gamaS / (0.9 * fe)
                End If
                If ut > Atst Then Atst = ut
                'If phiAtProj(i1) > 0.001 Then id = i3
                st(i, i1) = (2 * PI * phiAt(i, i1) ^ 2 / 4) / Atst
                Select Case sism
                    Case 0 'poutre en zone non sismique ou lment secondaire
                        'phiAt(i1) = dio(i2) : i3 = i2 'diamtre et indice de l'acier
                        If st(i, i1) > StMax Then st(i, i1) = StMax
                    Case 1 'poutre en zone sismique
                        ' St0(i1, 1, 1) = 0.1
                        'phiAt(i1) = dio(i2) : i3 = i2 'diamtre et indice de l'acier
                End Select
                If sism = 1 Then 'dtermination de l'espacement maximal dans la zone critique
                    'If 24 * phiAt(i1) > 0.25 * d_Tr Then StmaxCrit = 0.25 * d_Tr Else StmaxCrit = 24 * phiAt(i1)
                    'If 8 * phi(i1, j, inf(i1, 1)) < StmaxCrit Then StmaxCrit = 8 * phi(i1, j, inf(i1, 1))
                    'If St0(i1, 1, 1) > StmaxCrit Then St0(i1, 1, 1) = StmaxCrit
                End If
                nbarT(i, i1) = CInt(Truncate(l(i) / st(i, i1))) + 1
                st(i, i1) = (Round((l(i) / nbarT(i, i1)) * 100)) / 100
                d = (dp(i) - 2 * enr) * 100
                lT(i, i1) = (Round(PI * d + 10 * phiAL(i, i1) * 100)) / 100
            Next
        Next

    End Sub
    Private Sub Calcul_ELU_section_circulaire(ByVal R As Double, ByVal couronne As Integer, ByVal Asi As Double, _
                ByVal rayon As Double, ByVal Ns As Double, ByVal Ms As Double, ByRef Verif As Boolean, ByVal i_typ As Integer, ByVal i_file As Integer)
        Dim Ma, Na, Nr, Mr, fcj, k As Double
        Dim Borne1, borne2, Solution1, Solution2, Pas As Double 'variables pour la dichotomie
        Dim iteration, i As Integer
        Dim msg As String
        'couronne = Nombre de couronnes d'aciers (de l'extrieur vers l'intrieur)
        Dim a(couronne), ra(couronne), fei(couronne) As Double
        For i = 1 To couronne
            ra(i) = rayon 'Console.Write("Rayon du cercle des armatures (m) : ")        'R = rayon de la section (m) 
            a(i) = Asi   ' Section totale des armatures (cm^2) : ")
            Select Case type_comb
                Case 1 'comb ELU fond,
                    fei(i) = fe / Vgs 'Console.Write("Fe (MPa) : ")
                Case 2 'comb ELU Accidentel,
                    Stop ' fei(i) = fe / ags 'Console.Write("Fe (MPa) : ")
                Case 3 'comb ELU Sismique
                    fei(i) = fe / sgs 'Console.Write("Fe (MPa) : ")
            End Select
        Next
        Select Case type_comb
            Case 1 'comb ELU fond,
                fcj = fc * 0.85 / Vgb 'fcj = Fc28 (MPa) :
            Case 2 'comb ELU Accidentel,
                Stop '    fcj = fc * 0.85 / agb 'fcj = Fc28 (MPa) :
            Case 3 'comb ELU Sismique
                fcj = fc * 0.85 / sgb 'fcj = Fc28 (MPa) :
        End Select

        'Eys = Module d'elasticite de l'acier E (MPa) 
        ' Ns = Effort normal N (KN) 
        'Ms = Moment (KN.m) 
        'Recherche des bornes de la solution
        Pas = R : Borne1 = 0 : borne2 = 0 : iteration = 1
        Do
            Borne1 = Borne1 - Pas : Yn0(i_typ, i_file) = Borne1
            Call N_resistant_beton(k, R, fcj, ra(1), i_typ, i_file) 'effort normal rsistant bton pour l'axe neutre y0
            Nra(i_typ, i_file) = 0
            For i = 1 To couronne
                Call N_resistant_acier(Na, Ma, k, R, ra, fei, a, i, i_typ, i_file) 'effort normal rsistant acier pour l'axe neutre y0
                Nra(i_typ, i_file) = Nra(i_typ, i_file) + Na
            Next
            Solution1 = Nrb(i_typ, i_file) + Nra(i_typ, i_file) - Ns
            borne2 = borne2 + Pas : Yn0(i_typ, i_file) = borne2
            Call N_resistant_beton(k, R, fcj, ra(1), i_typ, i_file) 'effort normal rsistant bton pour l'axe neutre y0
            Nra(i_typ, i_file) = 0
            For i = 1 To couronne
                Call N_resistant_acier(Na, Ma, k, R, ra, fei, a, i, i_typ, i_file) 'effort normal rsistant acier pour l'axe neutre y0
                Nra(i_typ, i_file) = Nra(i_typ, i_file) + Na
            Next
            Solution2 = Nrb(i_typ, i_file) + Nra(i_typ, i_file) - Ns
            iteration = iteration + 1
            If iteration = 50 Then
                msg = "Recherche des bornes de la solution:" & vbCrLf & _
                "Aucune solution trouve aprs plus de 50 itrations"
                MsgBox(msg, MsgBoxStyle.Critical, "Module Calcul_Ferraillage")
                Verif = False
                Exit Sub
            End If
        Loop Until Solution1 * Solution2 < 0 'les 2 solutions sont bien de signe oppos
        'Modification des bornes tel que solution(borne1)>0 et solution(borne2)<0
        If Solution1 < 0 Then Pas = Borne1 : Borne1 = borne2 : borne2 = Pas
        'Recherche de la solution entre borne 1 et 2 par dichotomie
        iteration = 1
        Do
            Yn0(i_typ, i_file) = (Borne1 + borne2) / 2        'initialisation de l'axe neutre 
            Call N_resistant_beton(k, R, fcj, ra(1), i_typ, i_file) 'effort normal rsistant bton pour l'axe neutre y0
            Nra(i_typ, i_file) = 0 : Mra(i_typ, i_file) = 0
            For i = 1 To couronne
                Call N_resistant_acier(Na, Ma, k, R, ra, fei, a, i, i_typ, i_file) 'effort normal rsistant acier pour l'axe neutre y0
                Nra(i_typ, i_file) = Nra(i_typ, i_file) + Na : Mra(i_typ, i_file) = Mra(i_typ, i_file) + Ma
            Next
            Nr = Nrb(i_typ, i_file) + Nra(i_typ, i_file)
            Mr = Mrb(i_typ, i_file) + Mra(i_typ, i_file) ' 
            If (Nr - Ns) > 0 Then
                Borne1 = Yn0(i_typ, i_file)
            Else
                borne2 = Yn0(i_typ, i_file)
            End If
            iteration = iteration + 1
            If iteration = 1000 Then
                msg = "Recherche de la solution:" & vbCrLf & _
                    "Aucune solution trouve aprs plus de 1000 itrations" & vbCrLf & _
                    "Dtails du calcul : " & vbCrLf & _
                    "y0 : " & CStr(Yn0(i_typ, i_file)) & vbCrLf & _
                    "N rsistant (KN) = " & CStr(Nr) & vbCrLf & _
                    "M rsistant (KN.m) = " & CStr(Mr)
                MsgBox(msg, MsgBoxStyle.Critical, "Module Calcul_Ferraillage")
                Verif = False
                Exit Sub
            End If
        Loop Until Abs((borne2 - Borne1)) < 0.0005 'La prcision de l'axe neutre sera de l'ordre du 1/2mm

    End Sub
    Private Sub Calcul_ELS_section_circulaire(ByVal R As Double, ByVal couronne As Integer, ByVal Asi As Double, _
                ByVal rayon As Double, ByVal Ns As Double, ByVal Ms As Double, ByRef Verif As Boolean, ByVal i_typ As Integer, ByVal i_file As Integer)
        Dim kEb, My0, Ny0, u0, ub0 As Double
        Dim Borne1, borne2, Solution1, Solution2, Pas As Double 'variables pour la dichotomie
        Dim iteration, i As Integer
        Dim msg As String
        'Ns Effort normal N (KN) : ")
        'Ms=Moment (KN.m) : ")
        'R = rayon de la section (m)
        'couronne  = Nombre de couronnes d'aciers (de l'extrieur vers l'intrieur
        Dim a(couronne), ra(couronne), fei(couronne) As Double
        For i = 1 To couronne
            ra(i) = rayon 'Rayon du cercle des armatures (m) 
            a(i) = Asi '=Section totale des armatures (cm^2) 
        Next

        'Recherche des bornes de la solution
        Pas = R : Borne1 = 0 : borne2 = 0 : iteration = 1
        Do
            Borne1 = Borne1 - Pas : Yn0(i_typ, i_file) = Borne1
            u0 = Yn0(i_typ, i_file) / R
            Select Case u0
                Case Is > 1
                    ub0 = 1
                Case Is < -1
                    ub0 = -1
                Case Else
                    ub0 = u0
            End Select
            Call N_y0(Ny0, u0, ub0, a, couronne, R) 'effort normal pour l'axe neutre y0
            Call M_y0(My0, u0, ub0, a, couronne, R, ra) 'moment pour l'axe neutre y0
            Solution1 = Ny0 - (R * My0 * Ns / Ms)
            borne2 = borne2 + Pas : Yn0(i_typ, i_file) = borne2
            u0 = Yn0(i_typ, i_file) / R
            Select Case u0
                Case Is > 1
                    ub0 = 1
                Case Is < -1
                    ub0 = -1
                Case Else
                    ub0 = u0
            End Select
            Call N_y0(Ny0, u0, ub0, a, couronne, R) 'effort normal pour l'axe neutre y0
            Call M_y0(My0, u0, ub0, a, couronne, R, ra) 'moment pour l'axe neutre y0
            Solution2 = Ny0 - (R * My0 * Ns / Ms)
            iteration = iteration + 1
            If iteration = 50 Then
                msg = "Recherche des bornes de la solution:" & vbCrLf & _
                "Aucune solution trouve aprs plus de 50 itrations"
                MsgBox(msg, MsgBoxStyle.Critical, "Vrification section ELS")
                Verif = False
                Exit Sub
            End If
        Loop Until Solution1 * Solution2 < 0 'les 2 solutions sont bien de signe oppos
        'Modification des bornes tel que solution(borne1)>0 et solution(borne2)<0
        If Solution1 < 0 Then Pas = Borne1 : Borne1 = borne2 : borne2 = Pas
        'Recherche de la solution entre borne 1 et 2 par dichotomie
        iteration = 1
        Do
            Yn0(i_typ, i_file) = (Borne1 + borne2) / 2        'initialisation de l'axe neutre 
            u0 = Yn0(i_typ, i_file) / R
            Select Case u0
                Case Is > 1
                    ub0 = 1
                Case Is < -1
                    ub0 = -1
                Case Else
                    ub0 = u0
            End Select
            Call N_y0(Ny0, u0, ub0, a, couronne, R) 'effort normal pour l'axe neutre y0
            Call M_y0(My0, u0, ub0, a, couronne, R, ra) 'moment pour l'axe neutre y0
            Solution1 = Ny0 - (R * My0 * Ns / Ms)
            If Solution1 > 0 Then
                Borne1 = Yn0(i_typ, i_file)
            Else
                borne2 = Yn0(i_typ, i_file)
            End If
            iteration = iteration + 1
            If iteration = 1000 Then
                msg = "Recherche de la solution:" & vbCrLf & _
                    "Aucune solution trouve aprs plus de 1000 itrations" & vbCrLf & _
                    "Dtails du calcul : " & vbCrLf & _
                     "y0 : " & CStr(Yn0(i_typ, i_file)) & vbCrLf & _
                     "N  (KN) = " & CStr(Ny0) & vbCrLf & _
                   "M  (KN.m) = " & CStr(My0)
                MsgBox(msg, MsgBoxStyle.Critical, "Vrification section ELS")
                Verif = False
                Exit Sub
            End If
        Loop Until Abs((borne2 - Borne1)) < 0.0005 'La prcision de l'axe neutre sera de l'ordre du 1/2mm
        If Ns > 0.1 Then
            kEb = Ns / (Ny0 * R ^ 3)
        Else
            kEb = Ms / (My0 * R ^ 4)
        End If

        Sb(i_typ, i_file) = kEb * (R - Yn0(i_typ, i_file))
        Sbmoy(i_typ, i_file) = 2 * (fnf0(1) - fnf0(ub0))
        If Sbmoy(i_typ, i_file) > 0.1 Then
            Sbmoy(i_typ, i_file) = kEb * R * 2 * (u0 * (fnf0(ub0) - fnf0(1)) - fnf1(ub0)) / Sbmoy(i_typ, i_file)
        End If
        For i = 1 To couronne
            Sa(i_typ, i_file, i) = 15 * kEb * (-ra(i) - Yn0(i_typ, i_file))
        Next

        '######### MODULE AFFICHAGE DES RESULTATS ###################
        'Debug.WriteLine("Calcul termin  -  Itration n: " & CStr(iteration))
        'Debug.WriteLine("Axe neutre Y0 (m) = " & CStr(y0))
        'Debug.WriteLine("Solution1 = " & CStr(Solution1))
        'Debug.WriteLine("Contrainte bton sur la fibre suprieure(KN/m2) = " & CStr(Sb))
        'For i = 1 To couronne
        '    Debug.WriteLine("Contrainte acier " & CStr(i) & " (KN/m2) = " & CStr(Sa(i)))
        'Next
        'Debug.WriteLine("Contrainte moyenne sur le bton comprim (KN/m2) = " & CStr(Sbmoy))
        'Debug.Write("Contrainte  la fibre y = ")
        'y = CDbl(Debug.ReadLine())
        'If y > 0 Then
        '    Sy = kEb * (y - y0) : Sy1 = 15 * kEb * (y - y0)
        'Else
        '    Sy = 15 * kEb * (-y - y0) : Sy1 = 15 * kEb * (-y - y0)
        'End If
        'Debug.WriteLine("Contrainte bton sur la fibre suprieure (KN/m2) = " & CStr(Sy))
        'Debug.WriteLine("Contrainte acier sur la fibre suprieure (KN/m2) = " & CStr(Sy1))
    End Sub
    Private Sub Aciers(ByRef dio() As Double)
        Dim i As Integer
        For i = 1 To 6 : dio(i) = 0.006 + 0.002 * (i - 1) : Next i
        dio(7) = 0.02 : dio(8) = 0.025 : dio(9) = 0.032 : dio(10) = 0.04 ' diamtre acier
        'dio(11) = 0.0055 : dio(12) = 0.006 : dio(13) = 0.007 : dio(14) = 0.008 : dio(15) = 0.009
    End Sub
    Private Sub N_resistant_beton(ByRef k As Double, ByVal R As Double, ByVal fcj As Double, ByVal ra As Double, ByVal i_typ As Integer, ByVal i_file As Integer)
        Dim A, B, C, ebu, u0, ub0, ub, ubb, yb, yn, y1a, Ylim As Double
        'calcul de k = pente du diagramme des dformations suivant figure E6
        'Attention: changement de l'origine de l'ordonne entre figure et programme
        y1a = R - ra
        yn = 2 * R
        Ylim = ((20 * yn + 7 * y1a) / 27) - R
        Select Case Yn0(i_typ, i_file)
            Case Is >= Ylim 'pivot A
                k = 10 / ((Yn0(i_typ, i_file) + R) - y1a)
            Case Is > -R 'pivot B
                k = 3.5 / (yn - (Yn0(i_typ, i_file) + R))
            Case Is <= -R 'pivot C
                k = 3.5 / (yn - 7 * (Yn0(i_typ, i_file) + R) / 4)
            Case Else
                MsgBox("Problme") : Stop
        End Select
        u0 = Yn0(i_typ, i_file) / R
        Select Case u0
            Case Is > 1
                ub0 = 1
            Case Is < -1
                ub0 = -1
            Case Else
                ub0 = u0
        End Select
        'Calcul des fonctions A, B et C et de la valeur ub
        ebu = 2 'limite du palier lastique sur le bton
        yb = Yn0(i_typ, i_file) + ebu / k
        ub = yb / R
        A = (k * R) ^ 2
        B = 2 * A * ub
        C = A * (ub ^ 2)
        Select Case ub
            Case Is > 1
                ubb = 1
            Case Is < -1
                ubb = -1
            Case Else
                ubb = ub
        End Select
        Nrb(i_typ, i_file) = (A * fnf2(ubb) - B * fnf1(ubb) + C * fnf0(ubb)) - (A * fnf2(ub0) - B * fnf1(ub0) + (C - 4) * fnf0(ub0)) - PI
        Nrb(i_typ, i_file) = (fcj * R ^ 2 * Nrb(i_typ, i_file) / -2) * 1000
        Mrb(i_typ, i_file) = (A * fnf3(ubb) - B * fnf2(ubb) + C * fnf1(ubb)) - (A * fnf3(ub0) - B * fnf2(ub0) + (C - 4) * fnf1(ub0))
        Mrb(i_typ, i_file) = (fcj * R ^ 3 * Mrb(i_typ, i_file) / -2) * 1000
    End Sub
    Private Sub N_resistant_acier(ByRef Na As Double, ByRef Ma As Double, ByVal k As Double, _
                             ByVal R As Double, ByVal ra() As Double, ByVal fei() As Double, _
                             ByVal a() As Double, ByVal i As Integer, ByVal i_typ As Integer, ByVal i_file As Integer)
        Dim e1, u0, vap, vapb, vam, vamb, L As Double
        e1 = fei(i) / Eys 'limite du palier lastique pour l'acier
        e1 = e1 * 1000
        u0 = Yn0(i_typ, i_file) / R
        L = ra(i) / R
        vap = (k * R * u0 + e1) / (k * R * L)
        vam = (k * R * u0 - e1) / (k * R * L)
        Select Case vap
            Case Is > 1
                vapb = 1
            Case Is < -1
                vapb = -1
            Case Else
                vapb = vap
        End Select
        Select Case vam
            Case Is > 1
                vamb = 1
            Case Is < -1
                vamb = -1
            Case Else
                vamb = vam
        End Select
        Na = ((k * R * L * fng1(vapb) - (k * R * u0 + e1) * fng0(vapb))) - ((k * R * L * fng1(vamb) - (k * R * u0 - e1) * fng0(vamb)))
        Na = Na * Eys * a(i) / PI
        Ma = ((k * R * L * fng2(vapb) - (k * R * u0 + e1) * fng1(vapb))) - (k * R * L * fng2(vamb) - (k * R * u0 - e1) * fng1(vamb))
        Ma = L * R * Eys * a(i) * Ma / PI
    End Sub
    Private Sub N_y0(ByRef Ny0 As Double, ByVal u0 As Double, ByVal ub0 As Double, ByVal a() As Double, _
                     ByVal couronne As Integer, ByVal R As Double)
        Dim i As Integer
        Dim Sai As Double
        Sai = 0
        For i = 1 To couronne
            Sai = Sai + (a(i) * u0)
        Next
        Ny0 = 2 * (u0 * (fnf0(ub0) - fnf0(1)) - fnf1(ub0)) - (15 * Sai / (R ^ 2))
    End Sub
    Private Sub M_y0(ByRef My0 As Double, ByVal u0 As Double, ByVal ub0 As Double, ByVal a() As Double, _
                        ByVal couronne As Integer, ByVal R As Double, ByVal ra() As Double)
        Dim i As Integer
        Dim Sai, L As Double
        Sai = 0
        For i = 1 To couronne
            L = ra(i) / R
            Sai = Sai + (a(i) * L ^ 2)
        Next
        My0 = 2 * (u0 * fnf1(ub0) + fnf2(1) - fnf2(ub0)) + (15 / 2 * Sai / R ^ 2)
    End Sub
    'Private Sub dN_y0(ByRef dNy0 As Double, ByVal R As Double, ByVal ub0 As Double, ByVal a() As Double, _
    '                  ByVal couronne As Integer)
    '    Dim i As Integer
    '    Dim Sai As Double
    '    Sai = 0
    '    For i = 1 To couronne
    '        Sai = Sai + a(i)
    '    Next
    '    dNy0 = (2 * (fnf0(ub0) - fnf0(1)) - 15 * Sai / (R ^ 2)) '(R ^ 3) * 
    'End Sub
    'Private Sub dM_y0(ByRef dMy0 As Double, ByVal R As Double, ByVal ub0 As Double)
    '    dMy0 = 2 * R ^ 4 * fnf1(ub0)
    'End Sub
    Private Function fnf0(ByVal x As Double) As Double
        fnf0 = 0.5 * (Asin(x) + x * (1 - x ^ 2) ^ 0.5)
    End Function
    Private Function fnf1(ByVal x As Double) As Double
        fnf1# = ((1 - x ^ 2) ^ 1.5) / -3
    End Function
    Private Function fnf2(ByVal x As Double) As Double
        fnf2# = (Asin(x) - x * (1 - 2 * x ^ 2) * (1 - x ^ 2) ^ 0.5) / 8
    End Function
    Private Function fnf3(ByVal x As Double) As Double
        fnf3# = (((1 - x ^ 2) ^ 2.5) / 5) - (((1 - x ^ 2) ^ 1.5) / 3)
    End Function
    Private Function fng0(ByVal x As Double) As Double
        fng0# = Asin(x)
    End Function
    Private Function fng1(ByVal x As Double) As Double
        fng1# = -(1 - x ^ 2) ^ 0.5
    End Function
    Private Function fng2(ByVal x As Double) As Double
        fng2# = 0.5 * (Asin(x) - x * (1 - x ^ 2) ^ 0.5)
    End Function

End Module
