Imports System.IO
Module Lecture
    'Lecture et criture du fichier de donnes
    Dim title As String = "Pieux : module de lecture/criture"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly

#Region " Code de lecture du fichier de donnes "

    Public Sub Lecture_fichier(ByRef Donnee_OK As Boolean)
        ' The StreamReader must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamReader As StreamReader
        Dim i, k1, kk1, i_type, i_file, i_couche, choixx As Integer
        Dim toto, msg As String
        choixx = 0
        Try
            Donnee_OK = True
            i = 1 : k1 = 1 : kk1 = 1
            myStreamReader = File.OpenText(l_strFileName)
            toto = myStreamReader.ReadLine
            If toto <> "" Then Call titre(toto)
            While toto <> ""
                i = i + 1
                toto = myStreamReader.ReadLine
                If toto <> "" Then
                    Select Case choixx
                        Case 0
                            Call Donnees(toto, choixx, Donnee_OK)
                            If Donnee_OK = False Then Exit Sub
                        Case 1 'lecture des hypothses
                            Call Hypo(toto, k1, choixx)
                        Case 2 'lecture de la gomtrie des pieux
                            Call Geom(toto, k1, choixx, i_type, i_file)
                        Case 3 'Tirant
                            Call Tirants(toto, k1, choixx)
                        Case 4 'lecture des charges
                            Call Charges(toto, k1, choixx)
                        Case 5 'lecture sols
                            Call SOLS(toto, k1, choixx, i_type, i_couche)
                        Case 6 'lecture des aciers imposs
                            Call Aciers(toto, k1, choixx, kk1)
                    End Select
                End If
            End While

        Catch exc As Exception
            ' Show the exception to the user.
            MsgBox("Fichier non compatible avec cette version logicielle" + vbCrLf + "Exception: " + exc.Message)
            Donnee_OK = False
        Finally
            ' Close the object if it has been created.
            If Not myStreamReader Is Nothing Then
                myStreamReader.Close()
            End If
        End Try
    End Sub

    Private Sub titre(ByVal toto As String)
        Dim i, position As Integer
        Dim msg As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'crire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        position = InStr(toto, "pieux") 'dtermine l'emplacement de robot
        If position = 0 Then
            msg = "Il manque l'entte pieux dans votre fichier."
            MsgBox(msg, style, title)
        End If
    End Sub
    Private Sub Donnees(ByVal toto As String, ByRef choixx As Integer, ByRef Donnee_OK As Boolean)
        Dim blanc(15), i, j, k, position As Integer
        Dim msg, titi(10), tata, tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'crire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        tata = titi(1)
        If titi(1) = "'" Then Exit Sub 'cette chaine correspond  un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tata = titi(j) : tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                tata = titi(j)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                tata = titi(j + 1)
                titi(j + 1) = Trim(titi(j + 1)) : tata = titi(j + 1)
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'vrification si la chaine est un dbut de paragraphe
        'la chaine est un dbut de paragraphe
        tutu = Microsoft.VisualBasic.Left(titi(1), 3)
        Select Case tutu
            Case "hyp"
                choixx = 1
            Case "pie"
                choixx = 2
            Case "tir"
                choixx = 3
            Case "cha"
                choixx = 4
            Case "sol"
                choixx = 5
            Case "aci"
                choixx = 6
            Case Else
                Donnee_OK = False
        End Select

    End Sub
    Private Sub Hypo(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0

        Select Case k
            Case 1 'ligne 1 du paragraphe hypothse
                nomAffaire = titi(1) : ingenieur = titi(2)
            Case 2
                fc = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Vgb = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                Eyb(1) = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                Eyb(2) = CDbl(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
                enr = CDbl(titi(5))
                fis = CInt(titi(6))
                Choix_Eyb = CInt(titi(7))
            Case 3
                fe = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Vgs = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                Eys = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                espmin = CDbl(titi(4)) : If IsNumeric(titi(5)) = False Then Call Verification_point(titi(5))
                espMax = CDbl(titi(5))
            Case 4
                sism = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                sgb = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                sgs = CDbl(titi(3))
            Case 5
                Precision = CInt(titi(1)) : Fond72 = CInt(titi(2))
        End Select

        k = k + 1
        If k = 6 Then
            k = 1
            choixx = 0
        End If
    End Sub
    Private Sub Geom(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer, ByRef i_type As Integer, _
                     ByRef i_file As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim titi(10), tutu As String
        Dim nf_total As Integer
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        If k = 1 Then
            Ty = CInt(titi(1))
            Encastre = CBool(titi(2))
            ReDim dp(Ty), ipp(Ty), l(Ty), alpha(Ty), nf(Ty)
            i_type = 1
        Else
            nf_total = 0
            For j = 1 To i_type - 1
                nf_total = nf_total + nf(i_type - 1)
            Next
            If k = (i_type - 1) + nf_total + 2 Then
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                dp(i_type) = CDbl(titi(1))
                ipp(i_type) = CInt(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                l(i_type) = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                alpha(i_type) = CDbl(titi(4))
                nf(i_type) = CInt(titi(5))
                If k = 2 Then
                    ReDim y(Ty, Maxx(nf, Ty)), np(Ty, Maxx(nf, Ty))
                End If
                'transfert
                Dim AA(Ty, Maxx(nf, Ty)) As Double
                Dim BB(Ty, Maxx(nf, Ty)) As Integer
                Dim k2, k1 As Integer
                '-> transfert sens 1
                For k2 = 1 To i_type - 1
                    For k1 = 1 To nf(k2)
                        AA(k2, k1) = y(k2, k1) : BB(k2, k1) = np(k2, k1)
                    Next
                Next
                '-> redimensionnement
                ReDim y(Ty, Maxx(nf, Ty)), np(Ty, Maxx(nf, Ty))
                '-> transfert sens 2
                For k2 = 1 To Ty
                    For k1 = 1 To nf(k2)
                        y(k2, k1) = AA(k2, k1) : np(k2, k1) = BB(k2, k1)
                    Next
                Next
                Erase AA, BB
                i_file = 1
            Else
                np(i_type, i_file) = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                y(i_type, i_file) = CDbl(titi(2))
                i_file = i_file + 1
                If k = (i_type - 1) + nf_total + 2 + nf(i_type) Then i_type = i_type + 1
            End If
        End If

        k = k + 1 : nf_total = 100000000
        If nf(Ty) > 0.1 Then
            nf_total = 0
            For j = 1 To Ty
                nf_total = nf_total + nf(j)
            Next
        End If
        If k = Ty + nf_total + 2 Then
            k = 1
            choixx = 0 : i_type = 1
        End If
    End Sub
    Private Sub Tirants(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        Select Case k
            Case 1 'ligne 1 (nbTirant & " " & Ytirant & " " & muTirant & " " & alphaTirant)
                nbTirant = CInt(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Ytirant = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                muTirant = CDbl(titi(3)) : If IsNumeric(titi(4)) = False Then Call Verification_point(titi(4))
                alphaTirant = CDbl(titi(4))
        End Select

        k = k + 1
        If k = 2 Then
            k = 1
            choixx = 0
        End If
    End Sub
    Private Sub Charges(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        Select Case k
            Case 1 'ligne 1 
                type_comb = CInt(titi(1))
            Case 2
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                n0(1) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                t0(1) = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                m0(1) = CDbl(titi(3))
            Case 3
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                n0(2) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                t0(2) = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                m0(2) = CDbl(titi(3))
        End Select


        k = k + 1
        If k = 4 Then
            k = 1
            choixx = 0
        End If
    End Sub
    Private Sub SOLS(ByVal toto As String, ByRef k1 As Integer, ByRef choixx As Integer, ByRef i_type As Integer, _
                     ByRef i_couche As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim NcoucheTotal As Integer
        Dim titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        NcoucheTotal = 0
        For i = 1 To i_type - 1
            NcoucheTotal = NcoucheTotal + nCouche(i)
        Next
        If k1 = 1 Then
            ReDim nCouche(Ty)
            nCouche(i_type) = CInt(titi(1))
            ReDim h(Ty, Maxx(nCouche, Ty)), k(Ty, Maxx(nCouche, Ty), 2)
            i_type = 1 : i_couche = 1
        Else
            If k1 = NcoucheTotal + i_type Then
                nCouche(i_type) = CInt(titi(1))
                'transfert
                Dim AA(Ty, Maxx(nCouche, Ty)) As Double
                Dim BB(Ty, Maxx(nCouche, Ty), 2) As Double
                Dim k2, k3 As Integer
                '-> transfert sens 1
                For k2 = 1 To i_type - 1
                    For k3 = 1 To nCouche(k2)
                        AA(k2, k3) = h(k2, k3) : BB(k2, k3, 1) = k(k2, k3, 1) : BB(k2, k3, 2) = k(k2, k3, 2)
                    Next
                Next
                '-> redimensionnement
                ReDim h(Ty, Maxx(nCouche, Ty)), k(Ty, Maxx(nCouche, Ty), 2)
                '-> transfert sens 2
                For k2 = 1 To Ty
                    For k3 = 1 To nCouche(k2)
                        h(k2, k3) = AA(k2, k3) : k(k2, k3, 1) = BB(k2, k3, 1) : k(k2, k3, 2) = BB(k2, k3, 2)
                    Next
                Next
                Erase AA, BB
                i_couche = 1
            Else
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                h(i_type, i_couche) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                k(i_type, i_couche, 1) = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                k(i_type, i_couche, 2) = CDbl(titi(3))
                i_couche = i_couche + 1
                NcoucheTotal = 0
                For i = 1 To i_type
                    NcoucheTotal = NcoucheTotal + nCouche(i)
                Next
                If k1 = NcoucheTotal + i_type Then i_type = i_type + 1
            End If
        End If
        k1 = k1 + 1
        If i_type > Ty Then
            k1 = 1
            choixx = 0
        End If
    End Sub
    Private Sub Aciers(ByVal toto As String, ByRef k As Integer, ByRef choixx As Integer, ByRef k1 As Integer)
        Dim blanc(15), i, j, position, k2, k3 As Integer
        Dim msg, titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'For i = 1 To Ty
        '    For j = 1 To Maxx(nf, Ty)
        '        myStreamWriter.WriteLine( & " " &  & " " & ))
        '    Next
        'Next
        k3 = 0
        For i = 1 To k1
            k3 = k3 + nf(k1)
        Next
        If k > k3 Then
            k1 = k1 + 1
        End If
        k2 = k - k3
        If k2 <= 0 Then k2 = k 'valable unique pour le type n1
        If phiALproj Is Nothing Then
            ReDim phiAtproj(Ty, Maxx(nf, Ty)), phiALproj(Ty, Maxx(nf, Ty)), nbarLproj(Ty, Maxx(nf, Ty))
        ElseIf Ty + 1 > phiALproj.GetLength(0) Then
            ReDim phiAtproj(Ty, Maxx(nf, Ty)), phiALproj(Ty, Maxx(nf, Ty)), nbarLproj(Ty, Maxx(nf, Ty))
        End If
        If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
        phiAtproj(k1, k2) = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
        phiALproj(k1, k2) = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
        nbarLproj(k1, k2) = CInt(titi(3))


        k = k + 1
        If k = (Maxx(nf, Ty) * Ty) + 1 Then
            k = 1
            choixx = 0
        End If
    End Sub
    Private Sub Verification_point(ByRef tata As String)
        Dim position As Integer
        position = InStr(1, tata, ".")
        If position <> 0 Then
            Mid(tata, position) = ","
        End If
    End Sub
#End Region

#Region " Code d'criture du fichier de donnes "
    Public Sub Ecriture_Fichier()

        Dim myStreamWriter As StreamWriter
        Dim i, j As Integer
        Try
            myStreamWriter = File.CreateText(l_strFileName)

            myStreamWriter.WriteLine("Pieux beton arme")
            myStreamWriter.WriteLine("Hypothese")
            myStreamWriter.WriteLine(nomAffaire & " " & ingenieur)
            myStreamWriter.WriteLine(fc & " " & Vgb & " " & Eyb(1) & " " & Eyb(2) & " " & enr & " " & fis & " " & Choix_Eyb)
            myStreamWriter.WriteLine(fe & " " & Vgs & " " & Eys & " " & espmin & " " & espMax)
            myStreamWriter.WriteLine(sism & " " & sgb & " " & sgs)
            myStreamWriter.WriteLine(Precision & " " & Fond72)
            'Pieux
            myStreamWriter.WriteLine("Pieux")
            myStreamWriter.WriteLine(Ty & " " & Encastre)
            For i = 1 To Ty
                myStreamWriter.WriteLine(dp(i) & " " & ipp(i) & " " & l(i) & " " & alpha(i) & " " & nf(i))
                For j = 1 To nf(i)
                    myStreamWriter.WriteLine(np(i, j) & " " & y(i, j))
                Next
            Next
            'Tirants
            myStreamWriter.WriteLine("Tirants")
            myStreamWriter.WriteLine(nbTirant & " " & Ytirant & " " & muTirant & " " & alphaTirant)
            'charges
            myStreamWriter.WriteLine("Charges")
            myStreamWriter.WriteLine(type_comb)
            myStreamWriter.WriteLine(n0(1) & " " & t0(1) & " " & m0(1))
            myStreamWriter.WriteLine(n0(2) & " " & t0(2) & " " & m0(2))
            'sols
            myStreamWriter.WriteLine("sols")
            For i = 1 To Ty
                myStreamWriter.WriteLine(nCouche(i))
                For j = 1 To nCouche(i)
                    myStreamWriter.WriteLine(h(i, j) & " " & k(i, j, 1) & " " & k(i, j, 2))
                Next
            Next
            'Vrification
            myStreamWriter.WriteLine("Aciers projets")
            For i = 1 To Ty
                For j = 1 To Maxx(nf, Ty)
                    myStreamWriter.WriteLine(phiAtproj(i, j) & " " & phiALproj(i, j) & " " & nbarLproj(i, j))
                Next
            Next
            ' Flush the stream to ensure everything is flushed
            myStreamWriter.Flush()
        Catch exc As Exception
            MsgBox("Le fichier n'a pu tre ouvert ou crit" + vbCrLf + _
                "Merci de vrifier si le nom de fichier est correct, " + _
                "et si vous avez la permission d'crire dans le rpertoire indiqu " + _
              vbCrLf + vbCrLf + "Exception: " + exc.Message)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then
                myStreamWriter.Close()
            End If
        End Try
    End Sub
#End Region

End Module
