Imports System.Windows.Forms

Public Class frmCharges

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim verif As Boolean = True
        Call lecture(verif)
        If verif = False Then Exit Sub
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.Dispose()
        Me.Finalize()
    End Sub

#Region "Gestion des Textbox"

    Private Sub TextN1_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextN1.Enter
        TextN1.SelectionStart = 0
        TextN1.SelectionLength = TextN1.Text.Length
    End Sub

    Private Sub Textn1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextN1.KeyPress
        Call Gestion_Keypress(e, TextN1, False)
    End Sub

    Private Sub TextN2_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextN2.Enter
        TextN2.SelectionStart = 0
        TextN2.SelectionLength = TextN2.Text.Length
    End Sub
    Private Sub Textn2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextN2.KeyPress
        Call Gestion_Keypress(e, TextN2, False)
    End Sub

    Private Sub TextT1_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextT1.Enter
        TextT1.SelectionStart = 0
        TextT1.SelectionLength = TextT1.Text.Length
    End Sub
    Private Sub TextT1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextT1.KeyPress
        Call Gestion_Keypress(e, TextT1, False)
    End Sub

    Private Sub TextT2_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextT2.Enter
        TextT2.SelectionStart = 0
        TextT2.SelectionLength = TextT2.Text.Length
    End Sub
    Private Sub TextT2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextT2.KeyPress
        Call Gestion_Keypress(e, TextT2, False)
    End Sub

    Private Sub TextM1_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextM1.Enter
        TextM1.SelectionStart = 0
        TextM1.SelectionLength = TextM1.Text.Length
    End Sub
    Private Sub TextM1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextM1.KeyPress
        Call Gestion_Keypress(e, TextM1, False)
    End Sub

    Private Sub TextM2_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextM2.Enter
        TextM2.SelectionStart = 0
        TextM2.SelectionLength = TextM2.Text.Length
    End Sub
    Private Sub TextM2_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextM2.KeyPress
        Call Gestion_Keypress(e, TextM2, False)
    End Sub
#End Region

    Private Sub frmCharges_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call Additems()
        Call Affichage()
        CBoxUnite.SelectedIndex = 0
    End Sub
    Private Sub Additems()
        CBoxUnite.Items.Add("Les units sont en KN et KN.m")
        CBoxUnite.Items.Add("Les units sont en MN et MN.m")
        CBoxUnite.Items.Add("Les units sont en DaN et DaN.m")
    End Sub
    Private Sub Affichage()

        Dim F_N1, F_N2, F_T1, F_T2, F_M1, F_M2 As String
        Select Case type_comb
            Case 1 ' ELU Fond
                RbtnELUfond.Checked = True
            Case 2 'ELU Accidentel
                RbtnELUa.Checked = True
            Case 3 'ELU Sismique
                RbtnELUs.Checked = True
            Case 4 'ELS
                RbtnELS.Checked = True
        End Select
        Select Case CBoxUnite.SelectedIndex
            Case -1, 0 'KN et KN.m
                F_N1 = Format(n0(1), "#0.00") : F_N2 = Format(n0(2), "#0.00")
                F_T1 = Format(t0(1), "#0.00") : F_T2 = Format(t0(2), "#0.00")
                F_M1 = Format(m0(1), "#0.00") : F_M2 = Format(m0(2), "#0.00")
                Label12.Text = "(KN)" : Label13.Text = "(KN)" : Label14.Text = "(KN)" : Label15.Text = "(KN)"
                Label16.Text = "(KN.m)" : Label17.Text = "(KN.m)"
            Case 1 'MN et MN.m
                F_N1 = Format(n0(1) / 1000, "0.00000") : F_N2 = Format(n0(2) / 1000, "0.00000")
                F_T1 = Format(t0(1) / 1000, "0.00000") : F_T2 = Format(t0(2) / 1000, "0.00000")
                F_M1 = Format(m0(1) / 1000, "0.00000") : F_M2 = Format(m0(2) / 1000, "0.00000")
                Label12.Text = "(MN)" : Label13.Text = "(MN)" : Label14.Text = "(MN)" : Label15.Text = "(MN)"
                Label16.Text = "(MN.m)" : Label17.Text = "(MN.m)"
            Case 2 'DaN et DaN.m
                F_N1 = Format(n0(1) * 100, "#####0") : F_N2 = Format(n0(2) * 100, "#####0")
                F_T1 = Format(t0(1) * 100, "#####0") : F_T2 = Format(t0(2) * 100, "#####0")
                F_M1 = Format(m0(1) * 100, "#####0") : F_M2 = Format(m0(2) * 100, "#####0")
                Label12.Text = "(DaN)" : Label13.Text = "(DaN)" : Label14.Text = "(DaN)" : Label15.Text = "(DaN)"
                Label16.Text = "(DaN.m)" : Label17.Text = "(DaN.m)"
        End Select

        TextN1.Text = F_N1
        TextN2.Text = F_N2
        TextT1.Text = F_T1
        TextT2.Text = F_T2
        TextM1.Text = F_M1
        TextM2.Text = F_M2
    End Sub
    Private Sub lecture(ByRef Verif As Boolean)
        Try
            n0(1) = CDbl(TextN1.Text)
            n0(2) = CDbl(TextN2.Text)
            t0(1) = CDbl(TextT1.Text)
            t0(2) = CDbl(TextT2.Text)
            m0(1) = CDbl(TextM1.Text)
            m0(2) = CDbl(TextM2.Text)
            Select Case CBoxUnite.SelectedIndex
                Case -1, 0 'KN et KN.m
                    'Pas de modification
                Case 1 'MN et MN.m
                    n0(1) = n0(1) * 1000 : n0(2) = n0(2) * 1000 'MN -> KN
                    t0(1) = t0(1) * 1000 : t0(2) = t0(2) * 1000
                    m0(1) = m0(1) * 1000 : m0(2) = m0(2) * 1000
                Case 2 'DaN et DaN.m
                    n0(1) = n0(1) / 100 : n0(2) = n0(2) / 100 'DaN -> KN
                    t0(1) = t0(1) / 100 : t0(2) = t0(2) / 100
                    m0(1) = m0(1) / 100 : m0(2) = m0(2) / 100
            End Select
            type_comb = 0
            If RbtnELUfond.Checked = True Then type_comb = 1
            If RbtnELUa.Checked = True Then type_comb = 2 'ELU Accidentel
            If RbtnELUs.Checked = True Then type_comb = 3 'ELU Sismique
            If RbtnELS.Checked = True Then type_comb = 4 'ELS
            If type_comb = 0 Then
                MsgBox("Le type de combinaison n'a pas t renseign !", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
                Verif = False
            End If
        Catch ex As Exception
            Dim msg As String
            msg = "Erreur de lecture " & vbCrLf & "Exception : " & ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        End Try
    End Sub

    Private Sub CBoxUnite_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBoxUnite.SelectedIndexChanged
        Call Affichage()
    End Sub
End Class
