Imports System.Windows.Forms
Imports System.IO
Imports System.ComponentModel
Imports System.Drawing
Public Class frmPieux
    Private WithEvents pdoc As New Printing.PrintDocument()
    Private reponse As Integer
    'Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click

    'End Sub

    'Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    ' Utilisez My.Computer.Clipboard pour insérer les images ou le texte sélectionné dans le Presse-papiers
    'End Sub

    'Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    ' Utilisez My.Computer.Clipboard pour insérer les images ou le texte sélectionné dans le Presse-papiers
    'End Sub

    'Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    'Utilisez My.Computer.Clipboard.GetText() ou My.Computer.Clipboard.GetData pour extraire les informations du Presse-papiers.
    'End Sub

    'Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    Me.LayoutMdi(MdiLayout.Cascade)
    'End Sub

    'Private Sub TileVerticleToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    Me.LayoutMdi(MdiLayout.TileVertical)
    'End Sub

    'Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    Me.LayoutMdi(MdiLayout.TileHorizontal)
    'End Sub

    'Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    Me.LayoutMdi(MdiLayout.ArrangeIcons)
    'End Sub

    'Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
    '    ' Fermez tous les formulaires enfants du parent.
    '    For Each ChildForm As Form In Me.MdiChildren
    '        ChildForm.Close()
    '    Next
    'End Sub

    'Private m_ChildFormNumber As Integer = 0
    Private Sub frmdon_closed(ByVal sender As System.Object, ByVal e As CancelEventArgs) Handles MyBase.Closing
        If reponse = 6 Then
            e.Cancel = False
            End
        Else
            reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, Me.Text)
            If reponse = 6 Then
                e.Cancel = False
                End
            Else
                e.Cancel = True
            End If
        End If
    End Sub
    Private Sub frmPieux_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName).Length > 1 Then
            MsgBox("Application déjà lancée !")
            End
        End If
        mnuResultats.Enabled = False
        Call Mise_a_zero_generale()
        Dim frmsplash1 As frmSplash
        frmsplash1 = New frmSplash
        frmsplash1.ShowDialog()
    End Sub
    Private Sub Lecture_chaine(ByRef toto As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, position As Integer
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            position = InStrRev(toto, "\")
            i = i - position
            toto = Microsoft.VisualBasic.Right(toto, i)
        Catch ex As Exception
            Dim msg As String
            msg = "Le fichier n'a pas pu être lu" + vbCrLf + _
                "Merci de vérifier si le nom de fichier est correct, " + _
                vbCrLf + vbCrLf + "Exception: " + ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try

    End Sub
    Private Sub Verification(ByRef donnee_OK As Boolean)
        Dim i As Integer
        Dim msg, F_i As String
        If Encastre = False Then
            For i = 1 To Ty
                If ipp(i) = 1 Then
                    F_i = Format(i, "##")
                    msg = "Le pieux de type n°" & F_i & " est hypostatique." & vbCrLf & _
                            "Modifiez sa modélisation."
                    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
                    donnee_OK = False
                    Exit Sub
                End If
            Next
        End If
    End Sub
#Region "Gestion des menus"
    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        Dim message, title, defaultValue As String
        message = "Validez le nom de l'affaire"   ' Set prompt.
        title = "Pieux béton armé"   ' Set title.
        defaultValue = "Exemple 1"   ' Set default value.
        nomAffaire = InputBox(message, title, defaultValue)
        message = "Indiquez le nom du projeteur"
        defaultValue = "Bael 99"   ' Set default value.
        ingenieur = InputBox(message, title, defaultValue)
        Call Mise_a_zero_generale()    'mise à zéro de toutes les variables publiques
        mnuResultats.Enabled = False
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim donnee_OK As Boolean
        Dim Toto As String
        OpenFileDialog1.Title = "Ouvrir le projet"
        OpenFileDialog1.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        OpenFileDialog1.Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()
        If OpenFileDialog1.FileName <> "" Then
            Call Mise_a_zero_generale()    'mise à zéro de toutes les variables publiques
            l_strFileName = OpenFileDialog1.FileName
            Toto = l_strFileName
            Call Lecture_chaine(Toto)
            Me.Text = "Pieu : [ " & Toto & " ]"
            'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
            'sinon le calcul est arreté.
            Call Lecture_fichier(donnee_OK)
            mnuResultats.Enabled = False
            If donnee_OK = False Then Call Mise_a_zero_generale() 'ré-initialisation à 0 pour éviter tout souci
        End If
    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Dim donnee_OK As Boolean = True
        Dim msg As String
        Call Verification(donnee_OK)
        If donnee_OK = False Then Exit Sub
        If nomAffaire = "" Then
            msg = "Le nom de l'affaire n'a pas été renseigné." & vbCrLf & _
                  "Aucune sauvegarde possible."
            MsgBox(msg, vbCritical, Me.Text)
            Exit Sub
        End If
        l_strFileName = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data\" + nomAffaire + ".txt"
        Call Ecriture_Fichier()
        msg = "Fichier enregistré dans le répertoire :" & vbCrLf & _
                Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data" & vbCrLf & _
                        "sous le nom  " & nomAffaire & ".txt"
        MsgBox(msg, vbInformation, Me.Text)
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Dim donnee_OK As Boolean = True
        Call Verification(donnee_OK)
        If donnee_OK = False Then Exit Sub
        SaveFileDialog1.Title = "Enregistrer le projet sous ..."
        SaveFileDialog1.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        SaveFileDialog1.Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
        SaveFileDialog1.FilterIndex = 1
        SaveFileDialog1.RestoreDirectory = True
        SaveFileDialog1.ShowDialog()
        If SaveFileDialog1.FileName <> "" Then
            l_strFileName = SaveFileDialog1.FileName
            Call Ecriture_Fichier()
        End If
    End Sub

    Private Sub PrintSetupToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintSetupToolStripMenuItem.Click
        Dim ppd As New PrintPreviewDialog
        Try
            ppd.Document = pdoc
            ppd.ShowDialog()
        Catch exp As Exception
            MessageBox.Show("Pas d'imprimante connectée !", Me.Text, _
                 MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, "Poteau béton armé")
        If reponse = 6 Then
            '    Global.System.Windows.Forms.Application.Exit()
            End
        End If
    End Sub
    Private Sub mnuHypoCalcul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHypoCalcul.Click
        Dim frmHypocalcul1 As frmHypoCalcul
        frmHypocalcul1 = New frmHypoCalcul
        frmHypocalcul1.MdiParent = Me
        frmHypocalcul1.Show()
    End Sub
    Private Sub mnuSeisme_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSeisme.Click
        Dim frmSeisme1 As frmSeisme
        frmSeisme1 = New frmSeisme
        frmSeisme1.MdiParent = Me
        frmSeisme1.Show()
    End Sub
    Private Sub mnuVérification_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuVérification.Click
        If Ty >= 1 Then
            Dim frmVerif1 As frmVerif
            frmVerif1 = New frmVerif
            frmVerif1.MdiParent = Me
            frmVerif1.Show()
        Else
            Dim msg As String
            msg = "Vous devez d'abord renseigner la géométrie de la semelle"
            MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, Me.Text)
        End If

    End Sub
    Private Sub mnuBeton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuBeton.Click
        Dim frmBeton1 As frmBeton
        frmBeton1 = New frmBeton
        frmBeton1.Show()
    End Sub

    Private Sub mnuAcier_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAcier.Click
        Dim frmacier1 As frmAcier
        frmacier1 = New frmAcier
        frmacier1.Show()
    End Sub
    Private Sub mnuGeometrie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuGeometrie.Click
        Dim frmSemelle1 As frmSemelle
        frmSemelle1 = New frmSemelle
        frmSemelle1.ShowDialog()
    End Sub
    Private Sub TirantsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TirantsToolStripMenuItem.Click
        Dim frmTirant1 As frmTirant
        frmTirant1 = New frmTirant
        frmTirant1.MdiParent = Me
        frmTirant1.Show()
    End Sub
    Private Sub mnuSols_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSols.Click
        Dim frmSols1 As frmSols
        frmSols1 = New frmSols
        frmSols1.Show()
    End Sub
    Private Sub mnuCharges_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCharges.Click
        Dim frmCharges1 As frmCharges
        frmCharges1 = New frmCharges
        frmCharges1.Show()
    End Sub
    Private Sub mnuExecution_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExecution.Click
        Dim verif As Boolean = True
        Call Verification(verif)
        If verif = False Then Exit Sub
        Try
            Call Calcul_Pieux()
            If phiALproj(1, 1) > 0.001 Then
                Call Calcul_Ferraillage(verif)
                mnuPlan.Enabled = True
            Else
                mnuPlan.Enabled = False
            End If

            If verif = True Then
                MsgBox("Calcul terminée  !!!", MsgBoxStyle.Information Or MsgBoxStyle.OkOnly, "Module calcul")
                mnuResultats.Enabled = True
            End If
        Catch ex As Exception
            MsgBox("Erreur inattendue  !!!" & vbCrLf & ex.Message, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Module calcul")
            mnuResultats.Enabled = False
        End Try

    End Sub

    Private Sub mnuNoteDeCalcul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNoteDeCalcul.Click
        'If Calcul = False Then
        '    Dim msg As String
        '    msg = "Malgré les avertissements du module de calcul, voulez-vous" & vbCrLf & _
        '           "toujours visualiser la note de calcul ? (Oui/Non)" & vbCrLf & _
        '           "Attention, risque de plantage du logiciel"
        '    If MsgBox(msg, MsgBoxStyle.Information Or MsgBoxStyle.YesNo, "Soutènement") = MsgBoxResult.No Then Exit Sub
        'End If

        Call Note_de_calcul()
    End Sub
    Private Sub mnuPlan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPlan.Click
        Dim frmDessin1 As frmDessin
        frmDessin1 = New frmDessin
        frmDessin1.MdiParent = Me
        frmDessin1.Show()
    End Sub
    Private Sub mnuCourbesMoment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCourbesMoment.Click
        Dim frmcourbe1 As frmCourbe
        Affichage_Courbe = 1
        frmcourbe1 = New frmCourbe
        frmcourbe1.MdiParent = Me
        frmcourbe1.Show()
    End Sub

    Private Sub CourbesDesEffortsTranchantToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuTranchant.Click
        Dim frmcourbe1 As frmCourbe
        Affichage_Courbe = 2
        frmcourbe1 = New frmCourbe
        frmcourbe1.MdiParent = Me
        frmcourbe1.Show()
    End Sub

    Private Sub mnuPl_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPl.Click
        Dim frmcourbe1 As frmCourbe
        Affichage_Courbe = 3
        frmcourbe1 = New frmCourbe
        frmcourbe1.MdiParent = Me
        frmcourbe1.Show()
    End Sub

    Private Sub mnuRot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRot.Click
        Dim frmcourbe1 As frmCourbe
        Affichage_Courbe = 4
        frmcourbe1 = New frmCourbe
        frmcourbe1.MdiParent = Me
        frmcourbe1.Show()
    End Sub

    Private Sub mnuDeplac_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDeplac.Click
        Dim frmcourbe1 As frmCourbe
        Affichage_Courbe = 5
        frmcourbe1 = New frmCourbe
        frmcourbe1.MdiParent = Me
        frmcourbe1.Show()
    End Sub

    Private Sub mnuModuleK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuModuleK.Click
        Dim frmk1 As frmK
        frmk1 = New frmK
        frmk1.MdiParent = Me
        frmk1.Show()
    End Sub
    Private Sub mnuCalculatriceWindows_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCalculatriceWindows.Click
        Try
            Dim startInfo As New ProcessStartInfo("calc.exe")
            Process.Start(startInfo)
            startInfo.WindowStyle = ProcessWindowStyle.Normal
        Catch ex As Exception
            MsgBox("Problème d'accés à la calculatrice" + vbCrLf + _
                    vbCrLf + "Exception: " + ex.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Pieux")
        End Try
    End Sub
    Private Sub mnuCalculetteBA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCalculetteBA.Click
        Try
            Dim startInfo As New ProcessStartInfo("Section BA circulaire.exe")
            Process.Start(startInfo)
            startInfo.WindowStyle = ProcessWindowStyle.Normal
        Catch ex As Exception
            MsgBox("Problème d'accés à la calculatrice BA" + vbCrLf + _
                    vbCrLf + "Exception: " + ex.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Pieux")
        End Try
    End Sub
    Private Sub mnuCombinaisonAciersHA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCombinaisonAciersHA.Click
        Try
            Dim startInfo As New ProcessStartInfo("excel.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "BA_combinaisons_de_sections_armatures_HA.xls"
            Process.Start(startInfo)
        Catch ex As Exception
            MsgBox("Problème d'accés au logiciel Excel" + vbCrLf + _
                    vbCrLf + "Exception: " + ex.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Pieux")
        End Try
    End Sub
    Private Sub mnuAide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAide.Click
        Try
            Dim startInfo As New ProcessStartInfo("Aide_Pieux.doc")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            Process.Start(startInfo)
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher l'Aide" + vbCrLf + "Exception: " + ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub mnuApropos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuApropos.Click
        Dim frmsplash1 As frmSplash
        frmsplash1 = New frmSplash
        frmsplash1.ShowDialog()
    End Sub
#End Region

 
End Class
