Imports System.Windows.Forms

Public Class frmSols
    Private i_sol As Integer = 1 'N de la couche de sol
    Private i_type As Integer = 1 'N du type de pieu
    Private Ty1 As Integer = Ty 'nbre de type de pieu
    Private ncouche1(Ty) As Integer
    Private k1(,,) As Double
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Call Lecture_sol()
        Call lecture_Couche()
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Dim i, j As Integer
        If ncouche1(1) > 0.1 Then 'pour le cas 'd'annulation avec aucune entre initiale
            For i = 1 To Ty
                nCouche(Ty) = ncouche1(Ty)
                For j = 1 To nCouche(Ty)
                    k(i, j, 1) = k1(i, j, 1) : k(i, j, 2) = k1(i, j, 2)
                Next
            Next
        End If
        Me.Close()
    End Sub
#Region "Gestion des Textbox"

    Private Sub TextK_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextK.Enter
        TextK.SelectionStart = 0
        TextK.SelectionLength = TextK.Text.Length
    End Sub

    Private Sub Textk_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextK.KeyPress
        Call Gestion_Keypress(e, TextK, True)
    End Sub

    Private Sub TextNsol_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextNsol.Enter
        TextNsol.SelectionStart = 0
        TextNsol.SelectionLength = TextNsol.Text.Length
    End Sub
    Private Sub Textnsol_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNsol.KeyPress
        Call Gestion_Keypress(e, TextNsol, True)
    End Sub

    Private Sub TextEp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextEp.Enter
        TextEp.SelectionStart = 0
        TextEp.SelectionLength = TextEp.Text.Length
    End Sub
    Private Sub Textep_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextEp.KeyPress
        Call Gestion_Keypress(e, TextEp, True)
    End Sub
    Private Sub TextPf_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextPf.Enter
        TextPf.SelectionStart = 0
        TextPf.SelectionLength = TextPf.Text.Length
    End Sub

    Private Sub TextPf_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextPf.KeyPress
        Call Gestion_Keypress(e, TextPf, True)
    End Sub
#End Region

    Private Sub frmSols_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call Stockage_provisoire() 'sauvegarde des anciennes valeurs en cas d'annulation
        CBoxPression.Items.Add("Les units de pression sont en MPa")
        CBoxPression.Items.Add("Les units de pression sont en KPa")
        Call Affichage()
        If Ty + 1 > h.GetLength(0) Then 'taille du tableau sur la 1ire dimension
            ReDim k(Ty, 1, 2), h(Ty, 1), nCouche(Ty)
        End If
        TextNsol.Focus()
    End Sub
    Private Sub Stockage_provisoire()
        Dim i, j As Integer
        If nCouche(1) = 0 Then
            ncouche1(Ty) = 0 'pour le cas d'aucune entre initiale
        Else

            ReDim k1(Ty, Maxx(nCouche, Ty), 2)
            For i = 1 To Ty
                ncouche1(Ty) = nCouche(Ty)
                For j = 1 To ncouche1(Ty)
                    k1(i, j, 1) = k(i, j, 1) : k1(i, j, 2) = k(i, j, 2)
                Next
            Next
        End If
    End Sub
    Private Sub Affichage()
        Dim F_k, F_ep, F_nsol, F_Isol, F_Itype As String
        Select Case CBoxPression.SelectedIndex
            Case -1, 0 'MPa
                F_k = Format(k(i_type, i_sol, 2) / 1000, "##0.000")
                Label3.Text = "(MPa)" : Label4.Text = "(MPa)"
            Case 1 'KPa
                F_k = Format(k(i_type, i_sol, 2), "#####0")
                Label3.Text = "(KPa)" : Label4.Text = "(KPa)"
        End Select
        : F_ep = Format(h(i_type, i_sol), "#0.000")
        F_nsol = Format(nCouche(i_type), "#0")
        F_Isol = Format(i_sol, "#0") : F_Itype = Format(i_type, "#0")

        TextEp.Text = F_ep
        TextK.Text = F_k
        TextNsol.Text = F_nsol
        GB1.Text = "Couche de sol n" & F_Isol & " :"
        lblTypePieu.Text = "Caractristiques des couches de sol pour le pieu de type n" & F_Itype & " :"
    End Sub
    Private Sub Lecture_Sol()
        Try
            nCouche(i_type) = CInt(TextNsol.Text)
        Catch ex As Exception
            Dim msg As String
            msg = "Erreur de lecture " & vbCrLf & "Exception : " & ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub lecture_Couche()
        Try
            h(i_type, i_sol) = CDbl(TextEp.Text)
            k(i_type, i_sol, 2) = CDbl(TextK.Text) 'sous effort instantan
            Select Case CBoxPression.SelectedIndex
                Case -1, 0 'MPa
                    k(i_type, i_sol, 2) = k(i_type, i_sol, 2) * 1000 'Mpa -> KPa
                Case 1 'KPa
                    'Pas de modif
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Erreur de lecture " & vbCrLf & "Exception : " & ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub BtnPlusCouche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlusCouche.Click
        'affectation des diffrentes valeurs
        Call Lecture_Sol()
        Call lecture_Couche()

        i_sol = i_sol + 1
        If i_sol > nCouche(i_type) Then
            Dim msg As String
            msg = "Le nombre de couches de sol pour le type de pieu n" & CStr(i_type) & " est limit  " & CStr(nCouche(i_type))
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            i_sol = i_sol - 1
            TextNsol.Focus()
        End If
        'Vrification des dimensions des tableaux: attention, les tableaux commencent  l'indice 0.
        If nCouche(i_type) + 1 > h.GetLength(1) Then
            'Variables de transfert
            Dim AA(Ty, nCouche(i_type), 2), BB(Ty, nCouche(i_type)) As Double
            Dim k2, k1 As Integer
            k1 = h.GetLength(1)
            '-> transfert sens 1
            For k2 = 1 To Ty
                For k1 = 1 To h.GetLength(1) - 1
                    AA(k2, k1, 2) = k(k2, k1, 2)
                    BB(k2, k1) = h(k2, k1)
                Next
            Next
            '-> redimensionnement
            ReDim k(Ty, Maxx(nCouche, Ty), 2), h(Ty, Maxx(nCouche, Ty))
            '-> transfert sens 2
            For k2 = 1 To Ty
                For k1 = 1 To Maxx(nCouche, Ty)
                    k(k2, k1, 2) = AA(k2, k1, 2)
                    h(k2, k1) = BB(k2, k1)
                Next
            Next
            Erase AA, BB
        End If
        Dim F_i As String
        F_i = Format(i_sol, "#0")
        GB1.Text = "Couche de sol n" & F_i & " :"
        If h(i_type, i_sol) > 0.001 Then
            Call Affichage()
        Else
            'effacement de l'affichage complet
            TextK.Text = "" : TextEp.Text = ""
        End If
        TextEp.Focus()
    End Sub
    Private Sub BtnMoinsCouche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnMoinsCouche.Click
        'affectation des diffrentes valeurs
        Call Lecture_Sol()
        Call lecture_Couche()
        If i_sol = 1 Then Exit Sub
        i_sol = i_sol - 1
        Call Affichage()
    End Sub

    Private Sub BtnPieuPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPieuPlus.Click
        'affectation des diffrentes valeurs
        Call Lecture_Sol()
        Call lecture_Couche()
        i_type = i_type + 1
        If i_type > Ty Then
            Dim msg As String
            msg = "Le nombre de type de pieu est limit  " & CStr(Ty)
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            i_type = i_type - 1
            TextNsol.Focus()
            Exit Sub
        End If
        i_sol = 1
        Dim F_i, F_j As String
        F_i = Format(i_sol, "#0") : F_j = Format(i_type, "#0")
        GB1.Text = "Couche de sol n" & F_i & " :"
        lblTypePieu.Text = "Caractristiques des couches de sol pour le pieu de type n" & F_j & " :"
        If h(i_type, i_sol) > 0.001 Then
            Call Affichage()
        Else
            'effacement de l'affichage complet
            TextK.Text = "" : TextEp.Text = "" : TextNsol.Text = ""
        End If
        TextNsol.Focus()
    End Sub

    Private Sub BtnPieuMoins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPieuMoins.Click
        'affectation des diffrentes valeurs
        Call Lecture_Sol()
        Call lecture_Couche()
        If i_type = 1 Then Exit Sub
        i_type = i_type - 1
        Call Affichage()
    End Sub

    Private Sub CBoxPression_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBoxPression.SelectedIndexChanged
        Call Affichage()
    End Sub


End Class
