Imports System.Math
Public Class frmTirant

    Private Sub frmTirant_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call Affichage()
    End Sub
    Private Sub Affichage()
        If nbTirant = 0 Then
            TextNbTirant.Text = ""
            TextX.Text = ""
            TextMu.Text = ""
            Textalfa.Text = ""
        Else
            Dim F_nbTirant, F_Ytirant, F_muTirant, F_alphaTirant As String
            F_nbTirant = Format(nbTirant, "##") : F_Ytirant = Format(Ytirant, "#0.000")
            F_muTirant = Format(muTirant / 1000, "#####.00") : F_alphaTirant = Format(alphaTirant * 180 / PI, "##0.00")
            TextNbTirant.Text = F_nbTirant
            TextX.Text = F_Ytirant
            TextMu.Text = F_muTirant
            Textalfa.Text = F_alphaTirant
        End If
    End Sub
    Private Sub lecture()
        Try
            nbTirant = CInt(TextNbTirant.Text)
            Ytirant = CDbl(TextX.Text)
            muTirant = CDbl(TextMu.Text)
            muTirant = muTirant * 1000 'MPa -> KPa
            alphaTirant = CDbl(Textalfa.Text)
            alphaTirant = alphaTirant * pi / 180 'conversion degr->radians
        Catch ex As Exception
            MsgBox("Erreur dans l'entre des donnes" & vbCrLf & ex.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub


    Private Sub BtnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOK.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Call lecture()
        Me.Close()
    End Sub

    Private Sub BtnAnnuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAnnuler.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub
#Region "Gestion des Textbox"

    Private Sub TextNbTirant_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextNbTirant.Enter
        TextNbTirant.SelectionStart = 0
        TextNbTirant.SelectionLength = TextNbTirant.Text.Length
    End Sub
    Private Sub TextNbTirant_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNbTirant.KeyPress
        Call Gestion_Keypress(e, TextNbTirant, True)
    End Sub

    Private Sub TextMu_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextMu.Enter
        TextMu.SelectionStart = 0
        TextMu.SelectionLength = TextMu.Text.Length
    End Sub
    Private Sub TextMu_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextMu.KeyPress
        Call Gestion_Keypress(e, TextMu, True)
    End Sub
    Private Sub Textalfa_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Textalfa.Enter
        Textalfa.SelectionStart = 0
        Textalfa.SelectionLength = Textalfa.Text.Length
    End Sub

    Private Sub Textalfa_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Textalfa.KeyPress
        Call Gestion_Keypress(e, Textalfa, False)
    End Sub

    Private Sub TextX_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextX.Enter
        TextX.SelectionStart = 0
        TextX.SelectionLength = TextX.Text.Length
    End Sub

    Private Sub TextX_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextX.KeyPress
        Call Gestion_Keypress(e, TextX, False)
    End Sub
#End Region


End Class