Public Class frmHypoCalcul

    Private Sub frmHypoCalcul_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call affichage()
    End Sub
    Private Sub Affichage()
        Select Case Precision
            Case 10
                RbtnPrecisionStandard.Checked = True
            Case Else
                RbtnPrecisionAutre.Checked = True
                Dim F_precision As String
                F_precision = Format(Precision, "###")
                TextPrecision.Text = F_precision
        End Select
        Select Case Fond72
            Case 1
                RbtnModulIdent.Checked = True
            Case 2
                RbtnModulOkFond.Checked = True
        End Select
    End Sub
    Private Sub Lecture()
        If RbtnPrecisionStandard.Checked = True Then Precision = 10
        If RbtnPrecisionAutre.Checked = True Then
            Try
                If TextPrecision.Text = "" Then TextPrecision.Text = "0"
                Precision = CInt(TextPrecision.Text)
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Exclamation, Me.Text)
            End Try
        End If
        If RbtnModulOkFond.Checked = True Then Fond72 = 2
        If RbtnModulIdent.Checked = True Then Fond72 = 1
    End Sub
    Private Sub Verification(ByRef verif As Boolean)
        'If Precision < 10 Then
        '    Precision = 10
        '    Dim F_precision As String
        '    F_precision = Format(Precision, "###")
        '    TextPrecision.Text = F_precision
        'End If
    End Sub
    Private Sub BtnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOK.Click
        Dim verif As Boolean
        verif = True
        Call Lecture()
        Call Verification(verif)
        If verif = False Then Exit Sub
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub BtnAnnuler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAnnuler.Click
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub RbtnPrecisionAutre_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RbtnPrecisionAutre.CheckedChanged
        If RbtnPrecisionAutre.Checked = True Then
            TextPrecision.Enabled = True
            TextPrecision.Focus()
        Else
            TextPrecision.Enabled = False
            TextPrecision.Text = ""
        End If
    End Sub

    Private Sub TextPrecision_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextPrecision.Enter
        TextPrecision.SelectionStart = 0
        TextPrecision.SelectionLength = TextPrecision.Text.Length
    End Sub

    Private Sub TextPrecision_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextPrecision.KeyPress
        Call Gestion_Keypress(e, TextPrecision, True)
    End Sub
End Class