Public Class frmK

    Private Sub BtnCalcul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCalcul.Click
        Dim Em, K, R, alfa, mu As Double
        Dim donnee_OK As Boolean = True
        Call Lecture(Em, R, alfa, mu, donnee_OK)
        If donnee_OK = True Then Call Calcul_K(Em, K, R, alfa, mu)
    End Sub
    Private Sub Lecture(ByRef Em As Double, ByRef R As Double, ByRef alfa As Double, ByRef mu As Double, _
                        ByRef donnee_OK As Boolean)
        Try
            Em = CDbl(TextE.Text)
            R = CDbl(TextR.Text)
            alfa = CDbl(Textalfa.Text)
            mu = CDbl(Textmu.Text)
        Catch ex As Exception
            MsgBox("Mauvaise entre de donne" & vbCrLf & ex.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            donnee_OK = False
        End Try
    End Sub
    Private Sub Calcul_K(ByVal Em As Double, ByRef K As Double, ByVal R As Double, _
                        ByVal alfa As Double, ByVal mu As Double)
        Dim Ro As Double
        Dim F_K As String
        Ro = 0.3
        Select Case R
            Case Is >= 0.3 'formule itbtp = formule CCTG
                K = ((1 + mu) / (3 * Em)) * Ro * (2.65 * R / Ro) ^ alfa + alfa * R / (3 * Em)
                K = 2 / K
            Case Else 'formule CCTG 62
                K = 12 * Em / ((4 / 3) * 2.65 ^ alfa + alfa)
        End Select
        F_K = Format(K, "###0.00")
        lblK.Text = F_K
    End Sub

    Private Sub frmK_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblK.Text = ""
    End Sub
#Region "gestion des textbox"

    Private Sub TextE_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextE.Enter
        TextE.SelectionStart = 0
        TextE.SelectionLength = TextE.Text.Length
    End Sub
    Private Sub Texte_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextE.KeyPress
        Call Gestion_Keypress(e, TextE, True)
    End Sub

    Private Sub TextR_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextR.Enter
        TextR.SelectionStart = 0
        TextR.SelectionLength = TextR.Text.Length
    End Sub
    Private Sub Textr_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextR.KeyPress
        Call Gestion_Keypress(e, TextR, True)
    End Sub

    Private Sub Textalfa_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Textalfa.Enter
        Textalfa.SelectionStart = 0
        Textalfa.SelectionLength = Textalfa.Text.Length
    End Sub
    Private Sub Textalfa_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Textalfa.KeyPress
        Call Gestion_Keypress(e, Textalfa, True)
    End Sub

    Private Sub Textmu_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Textmu.Enter
        Textmu.SelectionStart = 0
        Textmu.SelectionLength = Textmu.Text.Length
    End Sub
    Private Sub Textmu_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Textmu.KeyPress
        Call Gestion_Keypress(e, Textmu, True)
    End Sub
#End Region

End Class