Imports System.Windows.Forms
Imports System.Math
Public Class frmSemelle

    Private i_pieu As Integer = 1
    Private i_file As Integer = 1 'n de la file de pieux
    Dim dp1(Ty), l1(Ty), alpha1(Ty), y1(Ty, nf(Ty)) As Double
    Dim np1(Ty, nf(Ty)), ipp1(Ty), nf1(Ty), TY1 As Integer
    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Call Lecture()
        Erase dp1, l1, alpha1, y1, np1, ipp1, nf1
        If phiALproj Is Nothing Then
            ReDim phiAtproj(Ty, Maxx(nf, Ty)), phiALproj(Ty, Maxx(nf, Ty)), nbarLproj(Ty, Maxx(nf, Ty))
        ElseIf Ty + 1 > phiALproj.GetLength(0) Then
            ReDim phiAtproj(Ty, Maxx(nf, Ty)), phiALproj(Ty, Maxx(nf, Ty)), nbarLproj(Ty, Maxx(nf, Ty))
        End If
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Call lecture_initialisation() 'pour affecter les anciennes valeurs
        Erase dp1, l1, alpha1, y1, np1, ipp1, nf1
        Me.Close()
    End Sub
#Region "Gestion des Textbox"

    Private Sub TextTY_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextTY.Enter
        TextTY.SelectionStart = 0
        TextTY.SelectionLength = TextTY.Text.Length
    End Sub

    Private Sub TextTY_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextTY.KeyPress
        Call Gestion_Keypress(e, TextTY, True)
    End Sub

    Private Sub Textdp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextDp.Enter
        TextDp.SelectionStart = 0
        TextDp.SelectionLength = TextDp.Text.Length
    End Sub
    Private Sub Textdp_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextDp.KeyPress
        Call Gestion_Keypress(e, TextDp, True)
    End Sub

    Private Sub TextAlpha_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextAlpha.Enter
        TextAlpha.SelectionStart = 0
        TextAlpha.SelectionLength = TextAlpha.Text.Length
    End Sub

    Private Sub Textalpha_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextAlpha.KeyPress
        Call Gestion_Keypress(e, TextAlpha, False)
    End Sub

    Private Sub TextL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextL.Enter
        TextL.SelectionStart = 0
        TextL.SelectionLength = TextL.Text.Length
    End Sub

    Private Sub Textl_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextL.KeyPress
        Call Gestion_Keypress(e, TextL, True)
    End Sub

    Private Sub TextNf_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextNf.Enter
        TextNf.SelectionStart = 0
        TextNf.SelectionLength = TextNf.Text.Length
    End Sub
    Private Sub Textnf_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNf.KeyPress
        Call Gestion_Keypress(e, TextNf, True)
    End Sub

    Private Sub TextNp_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextNp.Enter
        TextNp.SelectionStart = 0
        TextNp.SelectionLength = TextNp.Text.Length
    End Sub
    Private Sub Textnp_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextNp.KeyPress
        Call Gestion_Keypress(e, TextNp, True)
    End Sub
    Private Sub TextY_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextY.Enter
        TextY.SelectionStart = 0
        TextY.SelectionLength = TextY.Text.Length
    End Sub

    Private Sub TextY_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextY.KeyPress
        Call Gestion_Keypress(e, TextY, False)
    End Sub
#End Region
    Private Sub frmSemelle_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call initialisation() 'pour le cas ou il faudrait revenir aux valeurs initiales
        Call Affichage()
    End Sub
    Private Sub initialisation()
        Dim i, j As Integer
        For i = 1 To Ty
            dp1(i) = dp(i) : ipp1(i) = ipp(i) : l1(i) = l(i) : alpha1(i) = alpha(i) : nf1(i) = nf(i)
            For j = 1 To nf(i)
                np1(i, j) = np(i, j) : y1(i, j) = y(i, j)
            Next
        Next
        TY1 = Ty
    End Sub
    Private Sub Lecture_initialisation()
        Dim i, j As Integer '
        ReDim nf(TY1), np(TY1, Maxx(nf1, TY1)), ipp(TY1), dp(TY1), alpha(TY1), l(TY1), y(TY1, Maxx(nf1, TY1))
        For i = 1 To TY1
            dp(i) = dp1(i) : ipp(i) = ipp1(i) : l(i) = l1(i) : alpha(i) = alpha1(i) : nf(i) = nf1(i)
            For j = 1 To nf1(i)
                np(i, j) = np1(i, j) : y(i, j) = y1(i, j)
            Next
        Next
        Ty = TY1
    End Sub
    Private Sub Affichage()
        Dim F_ty, F_dp, F_L, F_Nf, F_alpha, F_np, F_y, F_i, F_j As String
        F_ty = Format(Ty, "#0") : F_dp = Format(dp(i_pieu) * 100, "#0") : F_L = Format(l(i_pieu), "#0.00")
        F_i = Format(i_pieu, "#0") : F_alpha = Format(alpha(i_pieu) * 180 / pi, "#0.00") : F_Nf = Format(nf(i_pieu), "#0")
        F_j = Format(i_file, "#0") : F_np = Format(np(i_pieu, i_file), "#0") : F_y = Format(y(i_pieu, i_file), "#0.00")
        TextTY.Text = F_ty
        lblCaracteristique.Text = "Caractristiques du pieu n" & F_i & " :"
        Select Case ipp(i_pieu)
            Case 1 'libre
                RbtnLibre.Checked = True
            Case 2 'articul
                RbtnArticule.Checked = True
            Case 3 'encastr
                RbtnEncastre.Checked = True
        End Select
        TextDp.Text = F_dp
        TextAlpha.Text = F_alpha
        TextL.Text = F_L
        TextNf.Text = F_Nf
        lblNbFiles.Text = "Nombre de files de pieux de type n" & F_i & " :"
        lblFiles.Text = "File n" & F_j
        TextNp.Text = F_np
        TextY.Text = F_y
        Select Case Encastre
            Case True
                RbtnTeteEncastre.Checked = True
            Case False
                RbtnTeteArticule.Checked = True
        End Select
    End Sub
    Private Sub Efface_Affichage()
        Dim F_ty, F_i, F_j As String
        F_ty = Format(Ty, "#0")
        F_i = Format(i_pieu, "#0")
        F_j = Format(i_file, "#0")
        TextTY.Text = F_ty
        lblCaracteristique.Text = "Caractristiques du pieu n" & F_i & " :"
        RbtnLibre.Checked = False
        RbtnArticule.Checked = False
        RbtnEncastre.Checked = False
        TextDp.Text = ""
        TextAlpha.Text = ""
        TextL.Text = ""
        TextNf.Text = ""
        lblNbFiles.Text = "Nombre de files de pieux de type n" & F_i & " :"
        lblFiles.Text = "File n" & F_j
        TextNp.Text = ""
        TextY.Text = ""
    End Sub
    Private Sub Lecture() '
        Try
            If TextTY.Text = "" Then TextTY.Text = "0"
            Ty = CInt(TextTY.Text) : If Ty = 0 Then Exit Sub
            dp(i_pieu) = CDbl(TextDp.Text)
            dp(i_pieu) = dp(i_pieu) / 100 'conversion en m
            If RbtnLibre.Checked = True Then ipp(i_pieu) = 1
            If RbtnArticule.Checked = True Then ipp(i_pieu) = 2 'articul
            If RbtnEncastre.Checked = True Then ipp(i_pieu) = 3 'encastr
            alpha(i_pieu) = CDbl(TextAlpha.Text)
            alpha(i_pieu) = alpha(i_pieu) * PI / 180 'transformation degr->radian
            l(i_pieu) = CDbl(TextL.Text)
            nf(i_pieu) = CInt(TextNf.Text)
            np(i_pieu, i_file) = CInt(TextNp.Text) 'provisoire
            y(i_pieu, i_file) = CDbl(TextY.Text) 'provisoire
            If RbtnTeteEncastre.Checked = True Then Encastre = True
            If RbtnTeteArticule.Checked = True Then Encastre = False
        Catch ex As Exception
            Dim msg As String
            msg = "Erreur de lecture " & vbCrLf & "Exception : " & ex.Message
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub BtnPieuPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPieuPlus.Click
        Dim msg As String
        If TextTY.Text = "" Then TextTY.Text = "0"
        Ty = CInt(TextTY.Text)
        If Ty = 0 Then
            msg = "Vous devez indiquer le nombre de type de pieux  "
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            TextTY.Focus()
            Exit Sub
        End If
        If i_pieu + 1 > Ty Then
            msg = "Le nombre de type de pieux est limit  " & CStr(Ty) & vbCrLf & "Modifiez cette valeur !"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            TextTY.Focus()
            Exit Sub
        End If
        'affectation des diffrentes valeurs
        Call Lecture()
        'Vrification des dimensions des tableaux: attention, les tableaux commencent  l'indice 0.
        i_pieu = i_pieu + 1
        If i_pieu + 1 > dp.GetLength(0) Then
            ReDim Preserve nf(i_pieu), ipp(i_pieu), dp(i_pieu), alpha(i_pieu), l(i_pieu)
            'transfert
            Dim AA(i_pieu, Maxx(nf, Ty)) As Double
            Dim BB(i_pieu, Maxx(nf, Ty)) As Integer
            Dim k, k1 As Integer
            '-> transfert sens 1
            For k = 1 To Ty
                For k1 = 1 To nf(k)
                    AA(k, k1) = y(k, k1) : BB(k, k1) = np(k, k1)
                Next
            Next
            '-> redimensionnement
            ReDim y(i_pieu, Maxx(nf, Ty)), np(i_pieu, Maxx(nf, Ty))
            '-> transfert sens 2
            For k = 1 To Ty
                For k1 = 1 To nf(k)
                    y(k, k1) = AA(k, k1) : np(k, k1) = BB(k, k1)
                Next
            Next
            Erase AA, BB
        End If
        Dim F_i, F_j As String
        F_i = Format(i_pieu, "#0") : F_j = Format(i_file, "#0")
        lblCaracteristique.Text = "Caractristiques du pieu n" & F_i & " :"
        lblNbFiles.Text = "Nombre de files de pieux de type n" & F_i & " :"
        lblFiles.Text = "File n" & F_j
        If dp(i_pieu) > 0.1 Then
            i_file = 1
            Call Affichage()
        Else
            'effacement de l'affichage complet
            Call Efface_Affichage()
        End If
        TextDp.Focus()
    End Sub
    Private Sub BtnPieuMoins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPieuMoins.Click
        If i_pieu = 1 Then Exit Sub
        Call Lecture()
        i_pieu = i_pieu - 1
        i_file = 1
        Call Affichage()
    End Sub
    Private Sub BtnFilPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnFilPlus.Click
        Dim msg As String
        If TextNf.Text = "" Then TextNf.Text = "0"
        nf(i_pieu) = CInt(TextNf.Text)
        If nf(i_pieu) = 0 Then
            msg = "Vous devez indiquer le nombre de files de pieux  "
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            TextNf.Focus()
            Exit Sub
        End If
        If i_file + 1 > nf(i_pieu) Then
            msg = "Le nombre de file de pieux est limit  " & CStr(nf(i_pieu)) & vbCrLf & "Modifiez cette valeur !"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            TextNf.Focus()
            Exit Sub
        End If
        'affectation des diffrentes valeurs
        np(i_pieu, i_file) = CInt(TextNp.Text) 'provisoire
        y(i_pieu, i_file) = CDbl(TextY.Text) 'provisoire
        'Vrification des dimensions des tableaux: attention, les tableaux commencent  l'indice 0.
        i_file = i_file + 1
        If i_file + 1 > y.GetLength(1) Then
            'transfert
            Dim AA(i_pieu, Maxx(nf, Ty)) As Double
            Dim BB(i_pieu, Maxx(nf, Ty)) As Integer
            Dim k, k1 As Integer
            '-> transfert sens 1
            For k = 1 To Ty
                For k1 = 1 To y.GetLength(1) - 1
                    AA(k, k1) = y(k, k1) : BB(k, k1) = np(k, k1)
                Next
            Next
            '-> redimensionnement
            ReDim y(i_pieu, Maxx(nf, Ty)), np(i_pieu, Maxx(nf, Ty))
            '-> transfert sens 2
            For k = 1 To Ty
                For k1 = 1 To nf(k)
                    y(k, k1) = AA(k, k1) : np(k, k1) = BB(k, k1)
                Next
            Next
        End If
        Dim F_j As String
        F_j = Format(i_file, "#0")
        lblFiles.Text = "File n" & F_j
        If np(i_pieu, i_file) > 0.1 Then
            TextNp.Text = CStr(np(i_pieu, i_file)) 'provisoire
            TextY.Text = CStr(y(i_pieu, i_file)) 'provisoire
        Else
            'effacement 
            TextNp.Text = "" 'provisoire
            TextY.Text = "" 'provisoire
        End If
        TextNp.Focus()
    End Sub
    Private Sub BtnFilMoins_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnFilMoins.Click
        If i_file = 1 Then Exit Sub
        Call Lecture()
        i_file = i_file - 1
        i_file = 1
        Dim F_j As String
        F_j = Format(i_file, "#0")
        lblFiles.Text = "File n" & F_j
        Call Affichage()
        TextNp.Focus()
    End Sub
End Class
